# $ANTLR 3.1.1 SlimWalkerIdentCheck.g 2014-12-10 14:05:23

import sys
from antlr3 import *
from antlr3.tree import *
from antlr3.compat import set, frozenset
         

from slim_compiler.src.dataStructure.compile import *
from slim_compiler.src.dataStructure.nominalbehaviour import *
from slim_compiler.src.dataStructure.errorbehaviour import *
from slim_compiler.src.dataStructure.expressions import *
from slim_compiler.src.errorManagement.errors import *



# for convenience in actions
HIDDEN = BaseRecognizer.HIDDEN

# token types
OE_PROP=120
FLOW=131
MINUS=97
WHEN=71
SEMICOLON=8
PROCESS=13
MODE_TRANS=117
ERROR=62
TRANSITIONS=35
FLOWS=104
IEPORT=110
ENUM=86
IN=21
DOT=27
LPAREN=58
CONNECTIONS=33
OUT=22
CASE=51
FQ_NAME_OR_IDENT=125
SEC=91
ATACTIVATION=42
MIN=92
ERR_CLOCK=122
PUBLIC=5
THEN=53
XOR=76
CLOCK=84
ERR_TRANS=123
FDIR=28
ERR_TYPE=108
ASSIGN=57
COMMENT=135
DIVIDE=98
GROUP=12
ARROW=39
EVENT_CONNECTION=127
MEMORY=15
OCCURRENCE=65
COMMA=60
ERR_IMPL=109
BUS=17
STATES=68
ERR_EVENT=121
IE_PROP=119
ODPORT=113
OBSERVABLE=29
LBRACKET=54
IDPORT=112
MODEL=10
PRIVATE=6
FEATURES=9
XNOR=77
PROB=102
MODES=34
UNARY_MINUS=130
ALPHANUM=134
LE=48
TO=73
NEQ=82
DAY=94
THREAD=11
PROPAGATION=64
NORMAL=128
SYSTEM=19
ACTIVATION=41
EVENTS=69
POISSON=67
ALARM=30
MODE=43
LT=47
RESET=56
CLOCKS=70
CONTINUOUS=85
EVENT=24
PASSIVE=105
PACKAGE=4
OEPORT=111
SUBCOMPONENTS=32
MODE_TRANS_PROB=118
ERRORPORT=114
NUMBER=133
SUBCOMPONENT=115
PORT=25
PROCESSOR=16
RUNNING=37
TRAJ_EXPR=129
ACCESSES=38
DEVICE=18
FIXED=66
TRUE=100
RPAREN=59
EQ=81
IMP=79
DATA_CONNECTION=126
NAME=124
DERIVATIVE=80
NOT=74
DATA=14
AND=46
OTHERWISE=52
REAL=88
END=7
PLUS=96
STORED=36
HOUR=93
INITIAL=40
IFF=78
STATE=61
WITHIN=72
INT=87
COMP_IMPL=107
NONBLOCKING=26
WS=136
EOF=-1
GE=50
ON=23
MSEC=90
COMP_TYPE=106
OR=75
MOD=99
TIMES=95
IMPLEMENTATION=31
NOMINAL=63
COLON=20
RBRACKET=55
GT=49
URGENT=44
IDENT=132
BOOL=83
WHILE=45
FALSE=101
PER=103
DEFAULT=89
THREAD_GROUP=116

# token names
tokenNames = [
    "<invalid>", "<EOR>", "<DOWN>", "<UP>", 
    "PACKAGE", "PUBLIC", "PRIVATE", "END", "SEMICOLON", "FEATURES", "MODEL", 
    "THREAD", "GROUP", "PROCESS", "DATA", "MEMORY", "PROCESSOR", "BUS", 
    "DEVICE", "SYSTEM", "COLON", "IN", "OUT", "ON", "EVENT", "PORT", "NONBLOCKING", 
    "DOT", "FDIR", "OBSERVABLE", "ALARM", "IMPLEMENTATION", "SUBCOMPONENTS", 
    "CONNECTIONS", "MODES", "TRANSITIONS", "STORED", "RUNNING", "ACCESSES", 
    "ARROW", "INITIAL", "ACTIVATION", "ATACTIVATION", "MODE", "URGENT", 
    "WHILE", "AND", "LT", "LE", "GT", "GE", "CASE", "OTHERWISE", "THEN", 
    "LBRACKET", "RBRACKET", "RESET", "ASSIGN", "LPAREN", "RPAREN", "COMMA", 
    "STATE", "ERROR", "NOMINAL", "PROPAGATION", "OCCURRENCE", "FIXED", "POISSON", 
    "STATES", "EVENTS", "CLOCKS", "WHEN", "WITHIN", "TO", "NOT", "OR", "XOR", 
    "XNOR", "IFF", "IMP", "DERIVATIVE", "EQ", "NEQ", "BOOL", "CLOCK", "CONTINUOUS", 
    "ENUM", "INT", "REAL", "DEFAULT", "MSEC", "SEC", "MIN", "HOUR", "DAY", 
    "TIMES", "PLUS", "MINUS", "DIVIDE", "MOD", "TRUE", "FALSE", "PROB", 
    "PER", "FLOWS", "PASSIVE", "COMP_TYPE", "COMP_IMPL", "ERR_TYPE", "ERR_IMPL", 
    "IEPORT", "OEPORT", "IDPORT", "ODPORT", "ERRORPORT", "SUBCOMPONENT", 
    "THREAD_GROUP", "MODE_TRANS", "MODE_TRANS_PROB", "IE_PROP", "OE_PROP", 
    "ERR_EVENT", "ERR_CLOCK", "ERR_TRANS", "NAME", "FQ_NAME_OR_IDENT", "DATA_CONNECTION", 
    "EVENT_CONNECTION", "NORMAL", "TRAJ_EXPR", "UNARY_MINUS", "FLOW", "IDENT", 
    "NUMBER", "ALPHANUM", "COMMENT", "WS"
]



class specification_scope(object):
    def __init__(self):
        self.the_package = None
class declaration_scope(object):
    def __init__(self):
        self.the_component = None


class SlimWalkerIdentCheck(TreeParser):
    grammarFileName = "SlimWalkerIdentCheck.g"
    antlr_version = version_str_to_tuple("3.1.1")
    antlr_version_str = "3.1.1"
    tokenNames = tokenNames

    def __init__(self, input, state=None):
        if state is None:
            state = RecognizerSharedState()

        TreeParser.__init__(self, input, state)


        self.dfa54 = self.DFA54(
            self, 54,
            eot = self.DFA54_eot,
            eof = self.DFA54_eof,
            min = self.DFA54_min,
            max = self.DFA54_max,
            accept = self.DFA54_accept,
            special = self.DFA54_special,
            transition = self.DFA54_transition
            )


	self.specification_stack = []
	self.declaration_stack = []





                


        



    # $ANTLR start "specification"
    # SlimWalkerIdentCheck.g:49:1: specification[compileInfo] : ( packageSpecification[compileInfo] | declaration[compileInfo] )+ ;
    def specification(self, compileInfo):
        self.specification_stack.append(specification_scope())
        try:
            try:
                # SlimWalkerIdentCheck.g:53:2: ( ( packageSpecification[compileInfo] | declaration[compileInfo] )+ )
                # SlimWalkerIdentCheck.g:53:4: ( packageSpecification[compileInfo] | declaration[compileInfo] )+
                pass 
                # SlimWalkerIdentCheck.g:53:4: ( packageSpecification[compileInfo] | declaration[compileInfo] )+
                cnt1 = 0
                while True: #loop1
                    alt1 = 3
                    LA1_0 = self.input.LA(1)

                    if (LA1_0 == PACKAGE) :
                        alt1 = 1
                    elif ((COMP_TYPE <= LA1_0 <= ERR_IMPL)) :
                        alt1 = 2


                    if alt1 == 1:
                        # SlimWalkerIdentCheck.g:53:5: packageSpecification[compileInfo]
                        pass 
                        self._state.following.append(self.FOLLOW_packageSpecification_in_specification59)
                        self.packageSpecification(compileInfo)

                        self._state.following.pop()


                    elif alt1 == 2:
                        # SlimWalkerIdentCheck.g:54:4: declaration[compileInfo]
                        pass 
                        if self._state.backtracking == 0:
                                
                            package = compileInfo.add_package("__default__", 0, 0)
                            self.specification_stack[-1].the_package = package.get_public_subpackage()
                            		

                        self._state.following.append(self.FOLLOW_declaration_in_specification70)
                        self.declaration(compileInfo)

                        self._state.following.pop()


                    else:
                        if cnt1 >= 1:
                            break #loop1

                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        eee = EarlyExitException(1, self.input)
                        raise eee

                    cnt1 += 1






            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            self.specification_stack.pop()
            pass

        return 

    # $ANTLR end "specification"


    # $ANTLR start "packageSpecification"
    # SlimWalkerIdentCheck.g:61:1: packageSpecification[compileInfo] : ^( PACKAGE i= ident PUBLIC ( declaration[compileInfo] )+ ( PRIVATE ( declaration[compileInfo] )+ )? j= ident ) ;
    def packageSpecification(self, compileInfo):

        i = None

        j = None


        try:
            try:
                # SlimWalkerIdentCheck.g:62:2: ( ^( PACKAGE i= ident PUBLIC ( declaration[compileInfo] )+ ( PRIVATE ( declaration[compileInfo] )+ )? j= ident ) )
                # SlimWalkerIdentCheck.g:62:4: ^( PACKAGE i= ident PUBLIC ( declaration[compileInfo] )+ ( PRIVATE ( declaration[compileInfo] )+ )? j= ident )
                pass 
                self.match(self.input, PACKAGE, self.FOLLOW_PACKAGE_in_packageSpecification88)

                self.match(self.input, DOWN, None)
                self._state.following.append(self.FOLLOW_ident_in_packageSpecification102)
                i = self.ident()

                self._state.following.pop()
                if self._state.backtracking == 0:
                       
                    #add the package if it was not already declared
                    package = compileInfo.add_package(((i is not None) and [i.name] or [None])[0],
                    					i.start.line, i.start.charPositionInLine + 1)
                    self.specification_stack[-1].the_package = package
                    		

                self.match(self.input, PUBLIC, self.FOLLOW_PUBLIC_in_packageSpecification120)
                if self._state.backtracking == 0:
                       
                    self.specification_stack[-1].the_package = package.get_public_subpackage()
                    		

                # SlimWalkerIdentCheck.g:78:5: ( declaration[compileInfo] )+
                cnt2 = 0
                while True: #loop2
                    alt2 = 2
                    LA2_0 = self.input.LA(1)

                    if ((COMP_TYPE <= LA2_0 <= ERR_IMPL)) :
                        alt2 = 1


                    if alt2 == 1:
                        # SlimWalkerIdentCheck.g:0:0: declaration[compileInfo]
                        pass 
                        self._state.following.append(self.FOLLOW_declaration_in_packageSpecification136)
                        self.declaration(compileInfo)

                        self._state.following.pop()


                    else:
                        if cnt2 >= 1:
                            break #loop2

                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        eee = EarlyExitException(2, self.input)
                        raise eee

                    cnt2 += 1


                # SlimWalkerIdentCheck.g:79:4: ( PRIVATE ( declaration[compileInfo] )+ )?
                alt4 = 2
                LA4_0 = self.input.LA(1)

                if (LA4_0 == PRIVATE) :
                    alt4 = 1
                if alt4 == 1:
                    # SlimWalkerIdentCheck.g:79:5: PRIVATE ( declaration[compileInfo] )+
                    pass 
                    self.match(self.input, PRIVATE, self.FOLLOW_PRIVATE_in_packageSpecification145)
                    if self._state.backtracking == 0:
                            
                        self.specification_stack[-1].the_package = package.get_private_subpackage()
                        			

                    # SlimWalkerIdentCheck.g:84:5: ( declaration[compileInfo] )+
                    cnt3 = 0
                    while True: #loop3
                        alt3 = 2
                        LA3_0 = self.input.LA(1)

                        if ((COMP_TYPE <= LA3_0 <= ERR_IMPL)) :
                            alt3 = 1


                        if alt3 == 1:
                            # SlimWalkerIdentCheck.g:0:0: declaration[compileInfo]
                            pass 
                            self._state.following.append(self.FOLLOW_declaration_in_packageSpecification162)
                            self.declaration(compileInfo)

                            self._state.following.pop()


                        else:
                            if cnt3 >= 1:
                                break #loop3

                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            eee = EarlyExitException(3, self.input)
                            raise eee

                        cnt3 += 1





                self._state.following.append(self.FOLLOW_ident_in_packageSpecification181)
                j = self.ident()

                self._state.following.pop()
                if self._state.backtracking == 0:
                       
                    if ((i is not None) and [i.name] or [None])[0] != ((j is not None) and [j.name] or [None])[0]:
                             	compileInfo.add_error(
                             			EndIdentifierOfPackageDoesNotMatchError(compileInfo.current_file,
                                 	                                            j.start.line,
                                     	                                        j.start.charPositionInLine + 1,
                                     	                                        "A-4", self.specification_stack[-1].the_package.parent,
                                         	                                    ((j is not None) and [j.name] or [None])[0]))
                    		


                self.match(self.input, UP, None)




            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return 

    # $ANTLR end "packageSpecification"


    # $ANTLR start "declaration"
    # SlimWalkerIdentCheck.g:102:1: declaration[compileInfo] : ( ^( COMP_TYPE ( FDIR )? cc= componentCategory i= ident ( portSpec[compileInfo] )* j= ident ) | ^(node= COMP_IMPL ( FDIR )? cc= componentCategory i= ident ( subcomponent[compileInfo] )* ( portConnection )* ( flow )* ( mode )* ( modeTransition )* j= ident ) | ^( ERR_TYPE i= ident ( errorFeature )* j= ident ) | ^( ERR_IMPL i= ident ( errorClock[compileInfo] )* ( errorState )* ( errorEvent )* ( errorTransition )* j= ident ) );
    def declaration(self, compileInfo):
        self.declaration_stack.append(declaration_scope())
        node = None
        cc = None

        i = None

        j = None


        try:
            try:
                # SlimWalkerIdentCheck.g:107:2: ( ^( COMP_TYPE ( FDIR )? cc= componentCategory i= ident ( portSpec[compileInfo] )* j= ident ) | ^(node= COMP_IMPL ( FDIR )? cc= componentCategory i= ident ( subcomponent[compileInfo] )* ( portConnection )* ( flow )* ( mode )* ( modeTransition )* j= ident ) | ^( ERR_TYPE i= ident ( errorFeature )* j= ident ) | ^( ERR_IMPL i= ident ( errorClock[compileInfo] )* ( errorState )* ( errorEvent )* ( errorTransition )* j= ident ) )
                alt18 = 4
                LA18 = self.input.LA(1)
                if LA18 == COMP_TYPE:
                    alt18 = 1
                elif LA18 == COMP_IMPL:
                    alt18 = 2
                elif LA18 == ERR_TYPE:
                    alt18 = 3
                elif LA18 == ERR_IMPL:
                    alt18 = 4
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 18, 0, self.input)

                    raise nvae

                if alt18 == 1:
                    # SlimWalkerIdentCheck.g:107:4: ^( COMP_TYPE ( FDIR )? cc= componentCategory i= ident ( portSpec[compileInfo] )* j= ident )
                    pass 
                    self.match(self.input, COMP_TYPE, self.FOLLOW_COMP_TYPE_in_declaration218)

                    if self._state.backtracking == 0:
                           
                        fdir = False
                        		


                    self.match(self.input, DOWN, None)
                    # SlimWalkerIdentCheck.g:111:5: ( FDIR )?
                    alt5 = 2
                    LA5_0 = self.input.LA(1)

                    if (LA5_0 == FDIR) :
                        alt5 = 1
                    if alt5 == 1:
                        # SlimWalkerIdentCheck.g:111:6: FDIR
                        pass 
                        self.match(self.input, FDIR, self.FOLLOW_FDIR_in_declaration229)
                        if self._state.backtracking == 0:
                            fdir = True 




                    self._state.following.append(self.FOLLOW_componentCategory_in_declaration242)
                    cc = self.componentCategory()

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_ident_in_declaration256)
                    i = self.ident()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                           	
                        if self.specification_stack[-1].the_package:
                        	self.declaration_stack[-1].the_component = \
                        		self.specification_stack[-1].the_package.add_component_type(((i is not None) and [i.name] or [None])[0],
                        		Category.str_to_category(cc), fdir, i.start.line,
                        		i.start.charPositionInLine + 1)
                        		

                    # SlimWalkerIdentCheck.g:124:5: ( portSpec[compileInfo] )*
                    while True: #loop6
                        alt6 = 2
                        LA6_0 = self.input.LA(1)

                        if ((IEPORT <= LA6_0 <= ERRORPORT)) :
                            alt6 = 1


                        if alt6 == 1:
                            # SlimWalkerIdentCheck.g:0:0: portSpec[compileInfo]
                            pass 
                            self._state.following.append(self.FOLLOW_portSpec_in_declaration273)
                            self.portSpec(compileInfo)

                            self._state.following.pop()


                        else:
                            break #loop6


                    self._state.following.append(self.FOLLOW_ident_in_declaration288)
                    j = self.ident()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                           
                        if self.declaration_stack[-1].the_component:
                        	if ((i is not None) and [i.name] or [None])[0] != ((j is not None) and [j.name] or [None])[0]:
                                 		compileInfo.add_error(
                                         	EndIdentifierOfComponentTypeDoesNotMatchError(compileInfo.current_file,
                                                                                       	  j.start.line,
                                                                                       	  j.start.charPositionInLine + 1,
                                                                                       	  "B-3", self.declaration_stack[-1].the_component,
                                                                                       	  ((j is not None) and [j.name] or [None])[0]))
                        		


                    self.match(self.input, UP, None)


                elif alt18 == 2:
                    # SlimWalkerIdentCheck.g:140:4: ^(node= COMP_IMPL ( FDIR )? cc= componentCategory i= ident ( subcomponent[compileInfo] )* ( portConnection )* ( flow )* ( mode )* ( modeTransition )* j= ident )
                    pass 
                    node=self.match(self.input, COMP_IMPL, self.FOLLOW_COMP_IMPL_in_declaration318)

                    if self._state.backtracking == 0:
                           
                        fdir = False
                        		


                    self.match(self.input, DOWN, None)
                    # SlimWalkerIdentCheck.g:144:5: ( FDIR )?
                    alt7 = 2
                    LA7_0 = self.input.LA(1)

                    if (LA7_0 == FDIR) :
                        alt7 = 1
                    if alt7 == 1:
                        # SlimWalkerIdentCheck.g:144:6: FDIR
                        pass 
                        self.match(self.input, FDIR, self.FOLLOW_FDIR_in_declaration329)
                        if self._state.backtracking == 0:
                            fdir = True 




                    self._state.following.append(self.FOLLOW_componentCategory_in_declaration341)
                    cc = self.componentCategory()

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_ident_in_declaration355)
                    i = self.ident()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                           
                        if self.specification_stack[-1].the_package:
                        	self.declaration_stack[-1].the_component = \
                        		self.specification_stack[-1].the_package.add_component_implementation(
                        		((i is not None) and [i.name] or [None])[0], Category.str_to_category(cc), fdir, i.start.line,
                        		i.start.charPositionInLine + 1)
                        		

                    # SlimWalkerIdentCheck.g:157:5: ( subcomponent[compileInfo] )*
                    while True: #loop8
                        alt8 = 2
                        LA8_0 = self.input.LA(1)

                        if (LA8_0 == 2 or LA8_0 == THREAD or (PROCESS <= LA8_0 <= SYSTEM) or LA8_0 == THREAD_GROUP) :
                            alt8 = 1


                        if alt8 == 1:
                            # SlimWalkerIdentCheck.g:0:0: subcomponent[compileInfo]
                            pass 
                            self._state.following.append(self.FOLLOW_subcomponent_in_declaration378)
                            self.subcomponent(compileInfo)

                            self._state.following.pop()


                        else:
                            break #loop8


                    # SlimWalkerIdentCheck.g:159:5: ( portConnection )*
                    while True: #loop9
                        alt9 = 2
                        LA9_0 = self.input.LA(1)

                        if ((DATA_CONNECTION <= LA9_0 <= EVENT_CONNECTION)) :
                            alt9 = 1


                        if alt9 == 1:
                            # SlimWalkerIdentCheck.g:0:0: portConnection
                            pass 
                            self._state.following.append(self.FOLLOW_portConnection_in_declaration392)
                            self.portConnection()

                            self._state.following.pop()


                        else:
                            break #loop9


                    # SlimWalkerIdentCheck.g:160:5: ( flow )*
                    while True: #loop10
                        alt10 = 2
                        LA10_0 = self.input.LA(1)

                        if (LA10_0 == FLOW) :
                            alt10 = 1


                        if alt10 == 1:
                            # SlimWalkerIdentCheck.g:0:0: flow
                            pass 
                            self._state.following.append(self.FOLLOW_flow_in_declaration399)
                            self.flow()

                            self._state.following.pop()


                        else:
                            break #loop10


                    if self._state.backtracking == 0:
                           
                        has_modes = False
                        		

                    # SlimWalkerIdentCheck.g:167:5: ( mode )*
                    while True: #loop11
                        alt11 = 2
                        LA11_0 = self.input.LA(1)

                        if ((INITIAL <= LA11_0 <= ACTIVATION) or LA11_0 == ERROR or LA11_0 == NORMAL) :
                            alt11 = 1


                        if alt11 == 1:
                            # SlimWalkerIdentCheck.g:167:6: mode
                            pass 
                            self._state.following.append(self.FOLLOW_mode_in_declaration428)
                            self.mode()

                            self._state.following.pop()
                            if self._state.backtracking == 0:
                                has_modes = True



                        else:
                            break #loop11


                    if self._state.backtracking == 0:
                           
                        if not has_modes:
                        	if self.declaration_stack[-1].the_component:
                        			self.declaration_stack[-1].the_component.add_initial_mode(
                        					DEFAULTINITMODE, None, None, -1, -1)
                        		

                    # SlimWalkerIdentCheck.g:176:5: ( modeTransition )*
                    while True: #loop12
                        alt12 = 2
                        LA12_0 = self.input.LA(1)

                        if ((MODE_TRANS <= LA12_0 <= MODE_TRANS_PROB)) :
                            alt12 = 1


                        if alt12 == 1:
                            # SlimWalkerIdentCheck.g:0:0: modeTransition
                            pass 
                            self._state.following.append(self.FOLLOW_modeTransition_in_declaration453)
                            self.modeTransition()

                            self._state.following.pop()


                        else:
                            break #loop12


                    self._state.following.append(self.FOLLOW_ident_in_declaration467)
                    j = self.ident()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                           
                        if self.declaration_stack[-1].the_component:
                        	if ((i is not None) and [i.name] or [None])[0] != ((j is not None) and [j.name] or [None])[0]:
                                 		compileInfo.add_error(
                                         	EndIdentifierOfComponentImplementationDoesNotMatchError(
                                                                                         compileInfo.current_file,
                                                                                         j.start.line,
                                                                                         j.start.charPositionInLine + 1,
                                                                                         "E-6", self.declaration_stack[-1].the_component,
                                                                             			((j is not None) and [j.name] or [None])[0]))        
                        				
                        		


                    self.match(self.input, UP, None)


                elif alt18 == 3:
                    # SlimWalkerIdentCheck.g:194:4: ^( ERR_TYPE i= ident ( errorFeature )* j= ident )
                    pass 
                    self.match(self.input, ERR_TYPE, self.FOLLOW_ERR_TYPE_in_declaration496)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_declaration510)
                    i = self.ident()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                           
                        if self.specification_stack[-1].the_package:
                        	self.declaration_stack[-1].the_component = \
                        		self.specification_stack[-1].the_package.add_error_type(((i is not None) and [i.name] or [None])[0],
                        		i.start.line, i.start.charPositionInLine + 1)
                        		

                    # SlimWalkerIdentCheck.g:205:5: ( errorFeature )*
                    while True: #loop13
                        alt13 = 2
                        LA13_0 = self.input.LA(1)

                        if ((INITIAL <= LA13_0 <= ACTIVATION) or LA13_0 == ERROR or (IE_PROP <= LA13_0 <= OE_PROP)) :
                            alt13 = 1


                        if alt13 == 1:
                            # SlimWalkerIdentCheck.g:0:0: errorFeature
                            pass 
                            self._state.following.append(self.FOLLOW_errorFeature_in_declaration540)
                            self.errorFeature()

                            self._state.following.pop()


                        else:
                            break #loop13


                    self._state.following.append(self.FOLLOW_ident_in_declaration554)
                    j = self.ident()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                           
                        if self.declaration_stack[-1].the_component:
                        	if ((i is not None) and [i.name] or [None])[0] != ((j is not None) and [j.name] or [None])[0]:
                        		compileInfo.add_error(
                        			EndIdentifierOfErrorTypeDoesNotMatchError(
                        					compileInfo.current_file, j.start.line,
                        					j.start.charPositionInLine + 1, "J-4", self.declaration_stack[-1].the_component,
                        					((j is not None) and [j.name] or [None])[0]))
                        																				
                        		


                    self.match(self.input, UP, None)


                elif alt18 == 4:
                    # SlimWalkerIdentCheck.g:221:4: ^( ERR_IMPL i= ident ( errorClock[compileInfo] )* ( errorState )* ( errorEvent )* ( errorTransition )* j= ident )
                    pass 
                    self.match(self.input, ERR_IMPL, self.FOLLOW_ERR_IMPL_in_declaration582)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_declaration596)
                    i = self.ident()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                           
                        if self.specification_stack[-1].the_package:
                        	self.declaration_stack[-1].the_component = \
                        		self.specification_stack[-1].the_package.add_error_implementation(((i is not None) and [i.name] or [None])[0],
                        		i.start.line, i.start.charPositionInLine + 1)
                        		

                    # SlimWalkerIdentCheck.g:231:5: ( errorClock[compileInfo] )*
                    while True: #loop14
                        alt14 = 2
                        LA14_0 = self.input.LA(1)

                        if (LA14_0 == ERR_CLOCK) :
                            alt14 = 1


                        if alt14 == 1:
                            # SlimWalkerIdentCheck.g:0:0: errorClock[compileInfo]
                            pass 
                            self._state.following.append(self.FOLLOW_errorClock_in_declaration618)
                            self.errorClock(compileInfo)

                            self._state.following.pop()


                        else:
                            break #loop14


                    # SlimWalkerIdentCheck.g:233:5: ( errorState )*
                    while True: #loop15
                        alt15 = 2
                        LA15_0 = self.input.LA(1)

                        if ((INITIAL <= LA15_0 <= ACTIVATION) or LA15_0 == ERROR) :
                            alt15 = 1


                        if alt15 == 1:
                            # SlimWalkerIdentCheck.g:0:0: errorState
                            pass 
                            self._state.following.append(self.FOLLOW_errorState_in_declaration635)
                            self.errorState()

                            self._state.following.pop()


                        else:
                            break #loop15


                    # SlimWalkerIdentCheck.g:235:5: ( errorEvent )*
                    while True: #loop16
                        alt16 = 2
                        LA16_0 = self.input.LA(1)

                        if (LA16_0 == ERR_EVENT) :
                            alt16 = 1


                        if alt16 == 1:
                            # SlimWalkerIdentCheck.g:0:0: errorEvent
                            pass 
                            self._state.following.append(self.FOLLOW_errorEvent_in_declaration648)
                            self.errorEvent()

                            self._state.following.pop()


                        else:
                            break #loop16


                    # SlimWalkerIdentCheck.g:237:5: ( errorTransition )*
                    while True: #loop17
                        alt17 = 2
                        LA17_0 = self.input.LA(1)

                        if (LA17_0 == ERR_TRANS) :
                            alt17 = 1


                        if alt17 == 1:
                            # SlimWalkerIdentCheck.g:0:0: errorTransition
                            pass 
                            self._state.following.append(self.FOLLOW_errorTransition_in_declaration661)
                            self.errorTransition()

                            self._state.following.pop()


                        else:
                            break #loop17


                    self._state.following.append(self.FOLLOW_ident_in_declaration675)
                    j = self.ident()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                           
                        if self.declaration_stack[-1].the_component:
                        	if ((i is not None) and [i.name] or [None])[0] != ((j is not None) and [j.name] or [None])[0]:
                        		compileInfo.add_error(
                        			EndIdentifierOfErrorImplementationDoesNotMatchError(
                        					compileInfo.current_file, j.start.line,
                        					j.start.charPositionInLine + 1, "K-11", self.declaration_stack[-1].the_component,
                        					((j is not None) and [j.name] or [None])[0]))
                        		


                    self.match(self.input, UP, None)



            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            self.declaration_stack.pop()
            pass

        return 

    # $ANTLR end "declaration"


    # $ANTLR start "componentCategory"
    # SlimWalkerIdentCheck.g:254:1: componentCategory returns [name] : ( | i= PROCESS | i= THREAD_GROUP | i= THREAD | i= PROCESSOR | i= MEMORY | i= DEVICE | i= BUS | i= SYSTEM );
    def componentCategory(self, ):

        name = None

        i = None

        try:
            try:
                # SlimWalkerIdentCheck.g:255:2: ( | i= PROCESS | i= THREAD_GROUP | i= THREAD | i= PROCESSOR | i= MEMORY | i= DEVICE | i= BUS | i= SYSTEM )
                alt19 = 9
                LA19 = self.input.LA(1)
                if LA19 == 2 or LA19 == NAME or LA19 == FQ_NAME_OR_IDENT or LA19 == IDENT:
                    alt19 = 1
                elif LA19 == PROCESS:
                    alt19 = 2
                elif LA19 == THREAD_GROUP:
                    alt19 = 3
                elif LA19 == THREAD:
                    alt19 = 4
                elif LA19 == PROCESSOR:
                    alt19 = 5
                elif LA19 == MEMORY:
                    alt19 = 6
                elif LA19 == DEVICE:
                    alt19 = 7
                elif LA19 == BUS:
                    alt19 = 8
                elif LA19 == SYSTEM:
                    alt19 = 9
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 19, 0, self.input)

                    raise nvae

                if alt19 == 1:
                    # SlimWalkerIdentCheck.g:256:2: 
                    pass 

                elif alt19 == 2:
                    # SlimWalkerIdentCheck.g:256:4: i= PROCESS
                    pass 
                    i=self.match(self.input, PROCESS, self.FOLLOW_PROCESS_in_componentCategory709)
                    if self._state.backtracking == 0:
                          
                        name = i.text
                        	



                elif alt19 == 3:
                    # SlimWalkerIdentCheck.g:260:4: i= THREAD_GROUP
                    pass 
                    i=self.match(self.input, THREAD_GROUP, self.FOLLOW_THREAD_GROUP_in_componentCategory719)
                    if self._state.backtracking == 0:
                          
                        name = "thread group"
                        	



                elif alt19 == 4:
                    # SlimWalkerIdentCheck.g:264:4: i= THREAD
                    pass 
                    i=self.match(self.input, THREAD, self.FOLLOW_THREAD_in_componentCategory729)
                    if self._state.backtracking == 0:
                          
                        name = i.text
                        	



                elif alt19 == 5:
                    # SlimWalkerIdentCheck.g:268:4: i= PROCESSOR
                    pass 
                    i=self.match(self.input, PROCESSOR, self.FOLLOW_PROCESSOR_in_componentCategory739)
                    if self._state.backtracking == 0:
                          
                        name = i.text
                        	



                elif alt19 == 6:
                    # SlimWalkerIdentCheck.g:272:4: i= MEMORY
                    pass 
                    i=self.match(self.input, MEMORY, self.FOLLOW_MEMORY_in_componentCategory749)
                    if self._state.backtracking == 0:
                          
                        name = i.text
                        	



                elif alt19 == 7:
                    # SlimWalkerIdentCheck.g:276:4: i= DEVICE
                    pass 
                    i=self.match(self.input, DEVICE, self.FOLLOW_DEVICE_in_componentCategory759)
                    if self._state.backtracking == 0:
                          
                        name = i.text
                        	



                elif alt19 == 8:
                    # SlimWalkerIdentCheck.g:280:4: i= BUS
                    pass 
                    i=self.match(self.input, BUS, self.FOLLOW_BUS_in_componentCategory769)
                    if self._state.backtracking == 0:
                          
                        name = i.text
                        	



                elif alt19 == 9:
                    # SlimWalkerIdentCheck.g:284:4: i= SYSTEM
                    pass 
                    i=self.match(self.input, SYSTEM, self.FOLLOW_SYSTEM_in_componentCategory779)
                    if self._state.backtracking == 0:
                          
                        name = i.text
                        	




            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return name

    # $ANTLR end "componentCategory"


    # $ANTLR start "dataType"
    # SlimWalkerIdentCheck.g:291:1: dataType[compileInfo] returns [dataType] : (i= BOOL | i= CLOCK (ts= timeScaleUnit )? | i= CONTINUOUS | ^(node= ENUM (elem= ident )+ ) | i= INT | i= REAL | r= intRange );
    def dataType(self, compileInfo):

        dataType = None

        i = None
        node = None
        ts = None

        elem = None

        r = None


        try:
            try:
                # SlimWalkerIdentCheck.g:292:2: (i= BOOL | i= CLOCK (ts= timeScaleUnit )? | i= CONTINUOUS | ^(node= ENUM (elem= ident )+ ) | i= INT | i= REAL | r= intRange )
                alt22 = 7
                LA22 = self.input.LA(1)
                if LA22 == BOOL:
                    alt22 = 1
                elif LA22 == CLOCK:
                    alt22 = 2
                elif LA22 == CONTINUOUS:
                    alt22 = 3
                elif LA22 == ENUM:
                    alt22 = 4
                elif LA22 == INT:
                    alt22 = 5
                elif LA22 == REAL:
                    alt22 = 6
                elif LA22 == NUMBER:
                    alt22 = 7
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 22, 0, self.input)

                    raise nvae

                if alt22 == 1:
                    # SlimWalkerIdentCheck.g:292:4: i= BOOL
                    pass 
                    i=self.match(self.input, BOOL, self.FOLLOW_BOOL_in_dataType803)
                    if self._state.backtracking == 0:
                          
                        dataType = Bool(compileInfo.current_file, i.line,
                        				 i.charPositionInLine + 1)
                        	



                elif alt22 == 2:
                    # SlimWalkerIdentCheck.g:298:2: i= CLOCK (ts= timeScaleUnit )?
                    pass 
                    if self._state.backtracking == 0:
                          
                        time_unit = None
                        	

                    i=self.match(self.input, CLOCK, self.FOLLOW_CLOCK_in_dataType819)
                    # SlimWalkerIdentCheck.g:301:11: (ts= timeScaleUnit )?
                    alt20 = 2
                    LA20 = self.input.LA(1)
                    if LA20 == MSEC:
                        LA20_1 = self.input.LA(2)

                        if (LA20_1 == 3 or (OBSERVABLE <= LA20_1 <= ALARM) or (AND <= LA20_1 <= CASE) or (NOT <= LA20_1 <= NEQ) or (MSEC <= LA20_1 <= FALSE) or (NAME <= LA20_1 <= FQ_NAME_OR_IDENT) or (TRAJ_EXPR <= LA20_1 <= UNARY_MINUS) or (IDENT <= LA20_1 <= NUMBER)) :
                            alt20 = 1
                    elif LA20 == SEC:
                        LA20_2 = self.input.LA(2)

                        if (LA20_2 == 3 or (OBSERVABLE <= LA20_2 <= ALARM) or (AND <= LA20_2 <= CASE) or (NOT <= LA20_2 <= NEQ) or (MSEC <= LA20_2 <= FALSE) or (NAME <= LA20_2 <= FQ_NAME_OR_IDENT) or (TRAJ_EXPR <= LA20_2 <= UNARY_MINUS) or (IDENT <= LA20_2 <= NUMBER)) :
                            alt20 = 1
                    elif LA20 == MIN:
                        LA20_3 = self.input.LA(2)

                        if (LA20_3 == 3 or (OBSERVABLE <= LA20_3 <= ALARM) or (AND <= LA20_3 <= CASE) or (NOT <= LA20_3 <= NEQ) or (MSEC <= LA20_3 <= FALSE) or (NAME <= LA20_3 <= FQ_NAME_OR_IDENT) or (TRAJ_EXPR <= LA20_3 <= UNARY_MINUS) or (IDENT <= LA20_3 <= NUMBER)) :
                            alt20 = 1
                    elif LA20 == HOUR:
                        LA20_4 = self.input.LA(2)

                        if (LA20_4 == 3 or (OBSERVABLE <= LA20_4 <= ALARM) or (AND <= LA20_4 <= CASE) or (NOT <= LA20_4 <= NEQ) or (MSEC <= LA20_4 <= FALSE) or (NAME <= LA20_4 <= FQ_NAME_OR_IDENT) or (TRAJ_EXPR <= LA20_4 <= UNARY_MINUS) or (IDENT <= LA20_4 <= NUMBER)) :
                            alt20 = 1
                    elif LA20 == DAY:
                        LA20_5 = self.input.LA(2)

                        if (LA20_5 == 3 or (OBSERVABLE <= LA20_5 <= ALARM) or (AND <= LA20_5 <= CASE) or (NOT <= LA20_5 <= NEQ) or (MSEC <= LA20_5 <= FALSE) or (NAME <= LA20_5 <= FQ_NAME_OR_IDENT) or (TRAJ_EXPR <= LA20_5 <= UNARY_MINUS) or (IDENT <= LA20_5 <= NUMBER)) :
                            alt20 = 1
                    if alt20 == 1:
                        # SlimWalkerIdentCheck.g:301:12: ts= timeScaleUnit
                        pass 
                        self._state.following.append(self.FOLLOW_timeScaleUnit_in_dataType824)
                        ts = self.timeScaleUnit()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            time_unit=ts




                    if self._state.backtracking == 0:
                          
                        dataType = Clock(time_unit, compileInfo.current_file, i.line,
                        				 i.charPositionInLine + 1)
                        	



                elif alt22 == 3:
                    # SlimWalkerIdentCheck.g:306:4: i= CONTINUOUS
                    pass 
                    i=self.match(self.input, CONTINUOUS, self.FOLLOW_CONTINUOUS_in_dataType837)
                    if self._state.backtracking == 0:
                          
                        dataType = Continuous(compileInfo.current_file, i.line,
                        				 i.charPositionInLine + 1)
                        	



                elif alt22 == 4:
                    # SlimWalkerIdentCheck.g:312:2: ^(node= ENUM (elem= ident )+ )
                    pass 
                    if self._state.backtracking == 0:
                          
                        values = []
                        	

                    node=self.match(self.input, ENUM, self.FOLLOW_ENUM_in_dataType855)

                    self.match(self.input, DOWN, None)
                    # SlimWalkerIdentCheck.g:317:5: (elem= ident )+
                    cnt21 = 0
                    while True: #loop21
                        alt21 = 2
                        LA21_0 = self.input.LA(1)

                        if ((NAME <= LA21_0 <= FQ_NAME_OR_IDENT) or LA21_0 == IDENT) :
                            alt21 = 1


                        if alt21 == 1:
                            # SlimWalkerIdentCheck.g:317:6: elem= ident
                            pass 
                            self._state.following.append(self.FOLLOW_ident_in_dataType870)
                            elem = self.ident()

                            self._state.following.pop()
                            if self._state.backtracking == 0:
                                values.append(((elem is not None) and [elem.name] or [None])[0]) 



                        else:
                            if cnt21 >= 1:
                                break #loop21

                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            eee = EarlyExitException(21, self.input)
                            raise eee

                        cnt21 += 1



                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        dataType = Enum(values, compileInfo.current_file, node.line,
                        				 node.charPositionInLine + 1)
                        		



                elif alt22 == 5:
                    # SlimWalkerIdentCheck.g:323:4: i= INT
                    pass 
                    i=self.match(self.input, INT, self.FOLLOW_INT_in_dataType889)
                    if self._state.backtracking == 0:
                          
                        dataType = Int(compileInfo.current_file, i.line,
                        				 i.charPositionInLine + 1)
                        	



                elif alt22 == 6:
                    # SlimWalkerIdentCheck.g:328:4: i= REAL
                    pass 
                    i=self.match(self.input, REAL, self.FOLLOW_REAL_in_dataType899)
                    if self._state.backtracking == 0:
                          
                        dataType = Real(compileInfo.current_file, i.line,
                        				 i.charPositionInLine + 1)
                        	



                elif alt22 == 7:
                    # SlimWalkerIdentCheck.g:333:6: r= intRange
                    pass 
                    self._state.following.append(self.FOLLOW_intRange_in_dataType911)
                    r = self.intRange()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                          
                        dataType = IntRange(((r is not None) and [r.lower] or [None])[0], ((r is not None) and [r.upper] or [None])[0], compileInfo.current_file,
                        					r.start.line, r.start.charPositionInLine + 1)
                        	




            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return dataType

    # $ANTLR end "dataType"


    # $ANTLR start "timeScaleUnit"
    # SlimWalkerIdentCheck.g:341:1: timeScaleUnit returns [unit] : (i= MSEC | i= SEC | i= MIN | i= HOUR | i= DAY );
    def timeScaleUnit(self, ):

        unit = None

        i = None

        try:
            try:
                # SlimWalkerIdentCheck.g:342:2: (i= MSEC | i= SEC | i= MIN | i= HOUR | i= DAY )
                alt23 = 5
                LA23 = self.input.LA(1)
                if LA23 == MSEC:
                    alt23 = 1
                elif LA23 == SEC:
                    alt23 = 2
                elif LA23 == MIN:
                    alt23 = 3
                elif LA23 == HOUR:
                    alt23 = 4
                elif LA23 == DAY:
                    alt23 = 5
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 23, 0, self.input)

                    raise nvae

                if alt23 == 1:
                    # SlimWalkerIdentCheck.g:342:4: i= MSEC
                    pass 
                    i=self.match(self.input, MSEC, self.FOLLOW_MSEC_in_timeScaleUnit933)
                    if self._state.backtracking == 0:
                          
                        unit = TimeUnitType.MSEC
                        	



                elif alt23 == 2:
                    # SlimWalkerIdentCheck.g:346:4: i= SEC
                    pass 
                    i=self.match(self.input, SEC, self.FOLLOW_SEC_in_timeScaleUnit943)
                    if self._state.backtracking == 0:
                          
                        unit = TimeUnitType.SEC
                        	



                elif alt23 == 3:
                    # SlimWalkerIdentCheck.g:350:4: i= MIN
                    pass 
                    i=self.match(self.input, MIN, self.FOLLOW_MIN_in_timeScaleUnit953)
                    if self._state.backtracking == 0:
                          
                        unit = TimeUnitType.MIN
                        	



                elif alt23 == 4:
                    # SlimWalkerIdentCheck.g:354:4: i= HOUR
                    pass 
                    i=self.match(self.input, HOUR, self.FOLLOW_HOUR_in_timeScaleUnit963)
                    if self._state.backtracking == 0:
                          
                        unit = TimeUnitType.HOUR
                        	



                elif alt23 == 5:
                    # SlimWalkerIdentCheck.g:358:4: i= DAY
                    pass 
                    i=self.match(self.input, DAY, self.FOLLOW_DAY_in_timeScaleUnit973)
                    if self._state.backtracking == 0:
                          
                        unit = TimeUnitType.DAY
                        	




            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return unit

    # $ANTLR end "timeScaleUnit"

    class intRange_return(TreeRuleReturnScope):
        def __init__(self):
            TreeRuleReturnScope.__init__(self)

            self.lower = None
            self.upper = None




    # $ANTLR start "intRange"
    # SlimWalkerIdentCheck.g:364:1: intRange returns [lower, upper] : low= NUMBER up= NUMBER ;
    def intRange(self, ):

        retval = self.intRange_return()
        retval.start = self.input.LT(1)

        low = None
        up = None

        try:
            try:
                # SlimWalkerIdentCheck.g:365:5: (low= NUMBER up= NUMBER )
                # SlimWalkerIdentCheck.g:365:9: low= NUMBER up= NUMBER
                pass 
                low=self.match(self.input, NUMBER, self.FOLLOW_NUMBER_in_intRange998)
                up=self.match(self.input, NUMBER, self.FOLLOW_NUMBER_in_intRange1002)
                if self._state.backtracking == 0:
                         
                    retval.lower = int(low.text)
                    retval.upper = int(up.text)
                    	





            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return retval

    # $ANTLR end "intRange"


    # $ANTLR start "portSpec"
    # SlimWalkerIdentCheck.g:372:1: portSpec[compileInfo] : ( ^( IEPORT i= ident ) | ^( OEPORT i= ident ( NONBLOCKING )? ) | ^( IDPORT i= ident d= dataType[compileInfo] (initval= expr[True] )? ) | ^( ODPORT i= ident d= dataType[compileInfo] (initval= expr[True] )? ( OBSERVABLE )? ( ALARM )? ) | ^( ERRORPORT i= ident ( POISSON NUMBER )? ) );
    def portSpec(self, compileInfo):

        POISSON1 = None
        NUMBER2 = None
        i = None

        d = None

        initval = None


        try:
            try:
                # SlimWalkerIdentCheck.g:374:2: ( ^( IEPORT i= ident ) | ^( OEPORT i= ident ( NONBLOCKING )? ) | ^( IDPORT i= ident d= dataType[compileInfo] (initval= expr[True] )? ) | ^( ODPORT i= ident d= dataType[compileInfo] (initval= expr[True] )? ( OBSERVABLE )? ( ALARM )? ) | ^( ERRORPORT i= ident ( POISSON NUMBER )? ) )
                alt30 = 5
                LA30 = self.input.LA(1)
                if LA30 == IEPORT:
                    alt30 = 1
                elif LA30 == OEPORT:
                    alt30 = 2
                elif LA30 == IDPORT:
                    alt30 = 3
                elif LA30 == ODPORT:
                    alt30 = 4
                elif LA30 == ERRORPORT:
                    alt30 = 5
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 30, 0, self.input)

                    raise nvae

                if alt30 == 1:
                    # SlimWalkerIdentCheck.g:374:4: ^( IEPORT i= ident )
                    pass 
                    self.match(self.input, IEPORT, self.FOLLOW_IEPORT_in_portSpec1028)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_portSpec1037)
                    i = self.ident()

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                          
                        if self.declaration_stack[-1].the_component:
                        	self.declaration_stack[-1].the_component.add_port(compileInfo.current_file, ((i is not None) and [i.name] or [None])[0], True, True, False, None, None,
                        		False, False, i.start.line, i.start.charPositionInLine + 1)
                        	



                elif alt30 == 2:
                    # SlimWalkerIdentCheck.g:385:4: ^( OEPORT i= ident ( NONBLOCKING )? )
                    pass 
                    self.match(self.input, OEPORT, self.FOLLOW_OEPORT_in_portSpec1057)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_portSpec1066)
                    i = self.ident()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                          
                        nonblocking = False
                        	

                    # SlimWalkerIdentCheck.g:390:5: ( NONBLOCKING )?
                    alt24 = 2
                    LA24_0 = self.input.LA(1)

                    if (LA24_0 == NONBLOCKING) :
                        alt24 = 1
                    if alt24 == 1:
                        # SlimWalkerIdentCheck.g:390:6: NONBLOCKING
                        pass 
                        self.match(self.input, NONBLOCKING, self.FOLLOW_NONBLOCKING_in_portSpec1076)
                        if self._state.backtracking == 0:
                            nonblocking = True




                    if self._state.backtracking == 0:
                          
                        if self.declaration_stack[-1].the_component:
                        	self.declaration_stack[-1].the_component.add_port(compileInfo.current_file, ((i is not None) and [i.name] or [None])[0], False, True, nonblocking, None, None,
                        		False, False, i.start.line, i.start.charPositionInLine + 1)
                        	


                    self.match(self.input, UP, None)


                elif alt30 == 3:
                    # SlimWalkerIdentCheck.g:398:4: ^( IDPORT i= ident d= dataType[compileInfo] (initval= expr[True] )? )
                    pass 
                    self.match(self.input, IDPORT, self.FOLLOW_IDPORT_in_portSpec1095)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_portSpec1104)
                    i = self.ident()

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_dataType_in_portSpec1118)
                    d = self.dataType(compileInfo)

                    self._state.following.pop()
                    # SlimWalkerIdentCheck.g:403:12: (initval= expr[True] )?
                    alt25 = 2
                    LA25_0 = self.input.LA(1)

                    if ((AND <= LA25_0 <= CASE) or (NOT <= LA25_0 <= NEQ) or (MSEC <= LA25_0 <= FALSE) or (NAME <= LA25_0 <= FQ_NAME_OR_IDENT) or (TRAJ_EXPR <= LA25_0 <= UNARY_MINUS) or (IDENT <= LA25_0 <= NUMBER)) :
                        alt25 = 1
                    if alt25 == 1:
                        # SlimWalkerIdentCheck.g:0:0: initval= expr[True]
                        pass 
                        self._state.following.append(self.FOLLOW_expr_in_portSpec1132)
                        initval = self.expr(True)

                        self._state.following.pop()



                    if self._state.backtracking == 0:
                          
                        if self.declaration_stack[-1].the_component:
                        	self.declaration_stack[-1].the_component.add_port(compileInfo.current_file, ((i is not None) and [i.name] or [None])[0], True, False, False, d,
                        		((initval is not None) and [initval.value] or [None])[0], False, False, i.start.line,
                        		i.start.charPositionInLine + 1)	
                        	


                    self.match(self.input, UP, None)


                elif alt30 == 4:
                    # SlimWalkerIdentCheck.g:413:4: ^( ODPORT i= ident d= dataType[compileInfo] (initval= expr[True] )? ( OBSERVABLE )? ( ALARM )? )
                    pass 
                    self.match(self.input, ODPORT, self.FOLLOW_ODPORT_in_portSpec1154)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_portSpec1163)
                    i = self.ident()

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_dataType_in_portSpec1177)
                    d = self.dataType(compileInfo)

                    self._state.following.pop()
                    # SlimWalkerIdentCheck.g:418:12: (initval= expr[True] )?
                    alt26 = 2
                    LA26_0 = self.input.LA(1)

                    if ((AND <= LA26_0 <= CASE) or (NOT <= LA26_0 <= NEQ) or (MSEC <= LA26_0 <= FALSE) or (NAME <= LA26_0 <= FQ_NAME_OR_IDENT) or (TRAJ_EXPR <= LA26_0 <= UNARY_MINUS) or (IDENT <= LA26_0 <= NUMBER)) :
                        alt26 = 1
                    if alt26 == 1:
                        # SlimWalkerIdentCheck.g:0:0: initval= expr[True]
                        pass 
                        self._state.following.append(self.FOLLOW_expr_in_portSpec1191)
                        initval = self.expr(True)

                        self._state.following.pop()



                    if self._state.backtracking == 0:
                          
                        observable = False
                        alarm = False
                        	

                    # SlimWalkerIdentCheck.g:423:5: ( OBSERVABLE )?
                    alt27 = 2
                    LA27_0 = self.input.LA(1)

                    if (LA27_0 == OBSERVABLE) :
                        alt27 = 1
                    if alt27 == 1:
                        # SlimWalkerIdentCheck.g:423:6: OBSERVABLE
                        pass 
                        self.match(self.input, OBSERVABLE, self.FOLLOW_OBSERVABLE_in_portSpec1203)
                        if self._state.backtracking == 0:
                            observable = True




                    # SlimWalkerIdentCheck.g:424:5: ( ALARM )?
                    alt28 = 2
                    LA28_0 = self.input.LA(1)

                    if (LA28_0 == ALARM) :
                        alt28 = 1
                    if alt28 == 1:
                        # SlimWalkerIdentCheck.g:424:6: ALARM
                        pass 
                        self.match(self.input, ALARM, self.FOLLOW_ALARM_in_portSpec1214)
                        if self._state.backtracking == 0:
                            alarm = True




                    if self._state.backtracking == 0:
                          
                        if self.declaration_stack[-1].the_component:
                        	self.declaration_stack[-1].the_component.add_port(compileInfo.current_file, ((i is not None) and [i.name] or [None])[0], False, False, False, d,
                        		((initval is not None) and [initval.value] or [None])[0], observable, alarm, i.start.line,
                        		i.start.charPositionInLine + 1)	
                        	


                    self.match(self.input, UP, None)


                elif alt30 == 5:
                    # SlimWalkerIdentCheck.g:434:4: ^( ERRORPORT i= ident ( POISSON NUMBER )? )
                    pass 
                    self.match(self.input, ERRORPORT, self.FOLLOW_ERRORPORT_in_portSpec1235)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_portSpec1239)
                    i = self.ident()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                          
                        distribution=None
                        param=None
                        	

                    # SlimWalkerIdentCheck.g:439:3: ( POISSON NUMBER )?
                    alt29 = 2
                    LA29_0 = self.input.LA(1)

                    if (LA29_0 == POISSON) :
                        alt29 = 1
                    if alt29 == 1:
                        # SlimWalkerIdentCheck.g:439:4: POISSON NUMBER
                        pass 
                        POISSON1=self.match(self.input, POISSON, self.FOLLOW_POISSON_in_portSpec1247)
                        if self._state.backtracking == 0:
                            distribution=POISSON1.text

                        NUMBER2=self.match(self.input, NUMBER, self.FOLLOW_NUMBER_in_portSpec1251)
                        if self._state.backtracking == 0:
                            param=NUMBER2.text




                    if self._state.backtracking == 0:
                          
                        if self.declaration_stack[-1].the_component:
                        	self.declaration_stack[-1].the_component.add_error_event_port(((i is not None) and [i.name] or [None])[0], distribution, param, None, 
                        		i.start.line, i.start.charPositionInLine + 1)
                        	


                    self.match(self.input, UP, None)



            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return 

    # $ANTLR end "portSpec"

    class ident_return(TreeRuleReturnScope):
        def __init__(self):
            TreeRuleReturnScope.__init__(self)

            self.name = None




    # $ANTLR start "ident"
    # SlimWalkerIdentCheck.g:448:1: ident returns [name] : ( ^( NAME type= ident i= ident ) | ^( FQ_NAME_OR_IDENT package= ident n= ident ) | IDENT );
    def ident(self, ):

        retval = self.ident_return()
        retval.start = self.input.LT(1)

        IDENT3 = None
        type = None

        i = None

        package = None

        n = None


        try:
            try:
                # SlimWalkerIdentCheck.g:450:2: ( ^( NAME type= ident i= ident ) | ^( FQ_NAME_OR_IDENT package= ident n= ident ) | IDENT )
                alt31 = 3
                LA31 = self.input.LA(1)
                if LA31 == NAME:
                    alt31 = 1
                elif LA31 == FQ_NAME_OR_IDENT:
                    alt31 = 2
                elif LA31 == IDENT:
                    alt31 = 3
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 31, 0, self.input)

                    raise nvae

                if alt31 == 1:
                    # SlimWalkerIdentCheck.g:450:4: ^( NAME type= ident i= ident )
                    pass 
                    self.match(self.input, NAME, self.FOLLOW_NAME_in_ident1281)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_ident1295)
                    type = self.ident()

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_ident_in_ident1309)
                    i = self.ident()

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        retval.name = ((type is not None) and [self.input.getTokenStream().toString(
                            self.input.getTreeAdaptor().getTokenStartIndex(type.start),
                            self.input.getTreeAdaptor().getTokenStopIndex(type.start)
                            )] or [None])[0] + "." + ((i is not None) and [self.input.getTokenStream().toString(
                            self.input.getTreeAdaptor().getTokenStartIndex(i.start),
                            self.input.getTreeAdaptor().getTokenStopIndex(i.start)
                            )] or [None])[0]
                        		



                elif alt31 == 2:
                    # SlimWalkerIdentCheck.g:460:4: ^( FQ_NAME_OR_IDENT package= ident n= ident )
                    pass 
                    self.match(self.input, FQ_NAME_OR_IDENT, self.FOLLOW_FQ_NAME_OR_IDENT_in_ident1325)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_ident1339)
                    package = self.ident()

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_ident_in_ident1353)
                    n = self.ident()

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if ((package is not None) and [self.input.getTokenStream().toString(
                            self.input.getTreeAdaptor().getTokenStartIndex(package.start),
                            self.input.getTreeAdaptor().getTokenStopIndex(package.start)
                            )] or [None])[0] != "": 
                        	retval.name = ((package is not None) and [self.input.getTokenStream().toString(
                            self.input.getTreeAdaptor().getTokenStartIndex(package.start),
                            self.input.getTreeAdaptor().getTokenStopIndex(package.start)
                            )] or [None])[0] + "::" + ((n is not None) and [self.input.getTokenStream().toString(
                            self.input.getTreeAdaptor().getTokenStartIndex(n.start),
                            self.input.getTreeAdaptor().getTokenStopIndex(n.start)
                            )] or [None])[0]
                        else:
                        	retval.name = ((n is not None) and [self.input.getTokenStream().toString(
                            self.input.getTreeAdaptor().getTokenStartIndex(n.start),
                            self.input.getTreeAdaptor().getTokenStopIndex(n.start)
                            )] or [None])[0]
                        		



                elif alt31 == 3:
                    # SlimWalkerIdentCheck.g:472:4: IDENT
                    pass 
                    IDENT3=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_ident1366)
                    if self._state.backtracking == 0:
                           
                        retval.name = IDENT3.text
                        		




            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return retval

    # $ANTLR end "ident"


    # $ANTLR start "subcomponent"
    # SlimWalkerIdentCheck.g:478:1: subcomponent[compileInfo] : ( ^( DATA i= ident (m= ident )* type= dataType[compileInfo] (initval= expr[True] )? ) | ^(cc= componentCategory i= ident impl= ident (m= ident )* (bind= binding )* ) );
    def subcomponent(self, compileInfo):

        i = None

        m = None

        type = None

        initval = None

        cc = None

        impl = None

        bind = None


        try:
            try:
                # SlimWalkerIdentCheck.g:480:2: ( ^( DATA i= ident (m= ident )* type= dataType[compileInfo] (initval= expr[True] )? ) | ^(cc= componentCategory i= ident impl= ident (m= ident )* (bind= binding )* ) )
                alt36 = 2
                LA36_0 = self.input.LA(1)

                if (LA36_0 == DATA) :
                    alt36 = 1
                elif (LA36_0 == 2 or LA36_0 == THREAD or LA36_0 == PROCESS or (MEMORY <= LA36_0 <= SYSTEM) or LA36_0 == THREAD_GROUP or (NAME <= LA36_0 <= FQ_NAME_OR_IDENT) or LA36_0 == IDENT) :
                    alt36 = 2
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 36, 0, self.input)

                    raise nvae

                if alt36 == 1:
                    # SlimWalkerIdentCheck.g:480:4: ^( DATA i= ident (m= ident )* type= dataType[compileInfo] (initval= expr[True] )? )
                    pass 
                    self.match(self.input, DATA, self.FOLLOW_DATA_in_subcomponent1386)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_subcomponent1402)
                    i = self.ident()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                           
                        in_modes = []
                        		

                    # SlimWalkerIdentCheck.g:487:5: (m= ident )*
                    while True: #loop32
                        alt32 = 2
                        LA32_0 = self.input.LA(1)

                        if ((NAME <= LA32_0 <= FQ_NAME_OR_IDENT) or LA32_0 == IDENT) :
                            alt32 = 1


                        if alt32 == 1:
                            # SlimWalkerIdentCheck.g:487:6: m= ident
                            pass 
                            self._state.following.append(self.FOLLOW_ident_in_subcomponent1421)
                            m = self.ident()

                            self._state.following.pop()
                            if self._state.backtracking == 0:
                                in_modes.append(((m is not None) and [m.name] or [None])[0]) 



                        else:
                            break #loop32


                    self._state.following.append(self.FOLLOW_dataType_in_subcomponent1444)
                    type = self.dataType(compileInfo)

                    self._state.following.pop()
                    # SlimWalkerIdentCheck.g:492:12: (initval= expr[True] )?
                    alt33 = 2
                    LA33_0 = self.input.LA(1)

                    if ((AND <= LA33_0 <= CASE) or (NOT <= LA33_0 <= NEQ) or (MSEC <= LA33_0 <= FALSE) or (NAME <= LA33_0 <= FQ_NAME_OR_IDENT) or (TRAJ_EXPR <= LA33_0 <= UNARY_MINUS) or (IDENT <= LA33_0 <= NUMBER)) :
                        alt33 = 1
                    if alt33 == 1:
                        # SlimWalkerIdentCheck.g:0:0: initval= expr[True]
                        pass 
                        self._state.following.append(self.FOLLOW_expr_in_subcomponent1459)
                        initval = self.expr(True)

                        self._state.following.pop()



                    if self._state.backtracking == 0:
                           
                        if self.declaration_stack[-1].the_component:
                        	self.declaration_stack[-1].the_component.add_data_subcomponent(((i is not None) and [i.name] or [None])[0],
                        		type, ((initval is not None) and [initval.value] or [None])[0], in_modes,
                        		i.start.line, i.start.charPositionInLine + 1)
                        		


                    self.match(self.input, UP, None)


                elif alt36 == 2:
                    # SlimWalkerIdentCheck.g:502:4: ^(cc= componentCategory i= ident impl= ident (m= ident )* (bind= binding )* )
                    pass 
                    self._state.following.append(self.FOLLOW_componentCategory_in_subcomponent1484)
                    cc = self.componentCategory()

                    self._state.following.pop()

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_subcomponent1498)
                    i = self.ident()

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_ident_in_subcomponent1512)
                    impl = self.ident()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                           
                        in_modes = []
                        		

                    # SlimWalkerIdentCheck.g:511:5: (m= ident )*
                    while True: #loop34
                        alt34 = 2
                        LA34_0 = self.input.LA(1)

                        if ((NAME <= LA34_0 <= FQ_NAME_OR_IDENT) or LA34_0 == IDENT) :
                            alt34 = 1


                        if alt34 == 1:
                            # SlimWalkerIdentCheck.g:511:6: m= ident
                            pass 
                            self._state.following.append(self.FOLLOW_ident_in_subcomponent1530)
                            m = self.ident()

                            self._state.following.pop()
                            if self._state.backtracking == 0:
                                in_modes.append(((m is not None) and [m.name] or [None])[0]) 



                        else:
                            break #loop34


                    if self._state.backtracking == 0:
                           
                        stored_in = []
                        running_on = []
                        accesses = []
                        		

                    # SlimWalkerIdentCheck.g:518:5: (bind= binding )*
                    while True: #loop35
                        alt35 = 2
                        LA35_0 = self.input.LA(1)

                        if ((STORED <= LA35_0 <= ACCESSES)) :
                            alt35 = 1


                        if alt35 == 1:
                            # SlimWalkerIdentCheck.g:518:6: bind= binding
                            pass 
                            self._state.following.append(self.FOLLOW_binding_in_subcomponent1553)
                            bind = self.binding()

                            self._state.following.pop()
                            if self._state.backtracking == 0:
                                     
                                if ((bind is not None) and [bind.type] or [None])[0] == "storedIn":
                                	stored_in.append(((bind is not None) and [bind.name] or [None])[0])
                                elif ((bind is not None) and [bind.type] or [None])[0] == "runningOn":
                                	running_on.append(((bind is not None) and [bind.name] or [None])[0])
                                elif ((bind is not None) and [bind.type] or [None])[0] == "accesses":
                                	accesses.append(((bind is not None) and [bind.name] or [None])[0])
                                				



                        else:
                            break #loop35


                    if self._state.backtracking == 0:
                           
                        if self.declaration_stack[-1].the_component:
                        	self.declaration_stack[-1].the_component.add_non_data_subcomponent(((i is not None) and [i.name] or [None])[0],
                        		Category.str_to_category(cc), ((impl is not None) and [impl.name] or [None])[0], accesses,
                        		stored_in, running_on, in_modes, i.start.line,
                        		i.start.charPositionInLine + 1)
                        		


                    self.match(self.input, UP, None)



            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return 

    # $ANTLR end "subcomponent"

    class binding_return(TreeRuleReturnScope):
        def __init__(self):
            TreeRuleReturnScope.__init__(self)

            self.type = None
            self.name = None




    # $ANTLR start "binding"
    # SlimWalkerIdentCheck.g:539:1: binding returns [type, name] : ( ^( STORED i= ident ) | ^( RUNNING i= ident ) | ^( ACCESSES i= ident ) );
    def binding(self, ):

        retval = self.binding_return()
        retval.start = self.input.LT(1)

        i = None


        try:
            try:
                # SlimWalkerIdentCheck.g:541:2: ( ^( STORED i= ident ) | ^( RUNNING i= ident ) | ^( ACCESSES i= ident ) )
                alt37 = 3
                LA37 = self.input.LA(1)
                if LA37 == STORED:
                    alt37 = 1
                elif LA37 == RUNNING:
                    alt37 = 2
                elif LA37 == ACCESSES:
                    alt37 = 3
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 37, 0, self.input)

                    raise nvae

                if alt37 == 1:
                    # SlimWalkerIdentCheck.g:541:4: ^( STORED i= ident )
                    pass 
                    self.match(self.input, STORED, self.FOLLOW_STORED_in_binding1596)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_binding1610)
                    i = self.ident()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                           
                        retval.type = "storedIn"
                        retval.name = ((i is not None) and [i.name] or [None])[0]
                        		


                    self.match(self.input, UP, None)


                elif alt37 == 2:
                    # SlimWalkerIdentCheck.g:551:4: ^( RUNNING i= ident )
                    pass 
                    self.match(self.input, RUNNING, self.FOLLOW_RUNNING_in_binding1631)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_binding1645)
                    i = self.ident()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                           
                        retval.type = "runningOn"
                        retval.name = ((i is not None) and [i.name] or [None])[0]
                        		


                    self.match(self.input, UP, None)


                elif alt37 == 3:
                    # SlimWalkerIdentCheck.g:560:4: ^( ACCESSES i= ident )
                    pass 
                    self.match(self.input, ACCESSES, self.FOLLOW_ACCESSES_in_binding1661)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_binding1675)
                    i = self.ident()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                           
                        retval.type = "accesses"
                        retval.name = ((i is not None) and [i.name] or [None])[0]
                        		


                    self.match(self.input, UP, None)



            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return retval

    # $ANTLR end "binding"


    # $ANTLR start "portConnection"
    # SlimWalkerIdentCheck.g:570:1: portConnection : ( ^( EVENT_CONNECTION fromPort= ident toPort= ident (i= ident )* ( PASSIVE )? ) | ^( DATA_CONNECTION fromPort= ident toPort= ident (i= ident )* ) );
    def portConnection(self, ):

        fromPort = None

        toPort = None

        i = None


        try:
            try:
                # SlimWalkerIdentCheck.g:572:2: ( ^( EVENT_CONNECTION fromPort= ident toPort= ident (i= ident )* ( PASSIVE )? ) | ^( DATA_CONNECTION fromPort= ident toPort= ident (i= ident )* ) )
                alt41 = 2
                LA41_0 = self.input.LA(1)

                if (LA41_0 == EVENT_CONNECTION) :
                    alt41 = 1
                elif (LA41_0 == DATA_CONNECTION) :
                    alt41 = 2
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 41, 0, self.input)

                    raise nvae

                if alt41 == 1:
                    # SlimWalkerIdentCheck.g:572:4: ^( EVENT_CONNECTION fromPort= ident toPort= ident (i= ident )* ( PASSIVE )? )
                    pass 
                    self.match(self.input, EVENT_CONNECTION, self.FOLLOW_EVENT_CONNECTION_in_portConnection1696)

                    if self._state.backtracking == 0:
                           
                        in_modes = []
                        passive = False;
                        		


                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_portConnection1717)
                    fromPort = self.ident()

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_ident_in_portConnection1731)
                    toPort = self.ident()

                    self._state.following.pop()
                    # SlimWalkerIdentCheck.g:584:5: (i= ident )*
                    while True: #loop38
                        alt38 = 2
                        LA38_0 = self.input.LA(1)

                        if ((NAME <= LA38_0 <= FQ_NAME_OR_IDENT) or LA38_0 == IDENT) :
                            alt38 = 1


                        if alt38 == 1:
                            # SlimWalkerIdentCheck.g:584:6: i= ident
                            pass 
                            self._state.following.append(self.FOLLOW_ident_in_portConnection1746)
                            i = self.ident()

                            self._state.following.pop()
                            if self._state.backtracking == 0:
                                in_modes.append(((i is not None) and [i.name] or [None])[0]) 



                        else:
                            break #loop38


                    # SlimWalkerIdentCheck.g:586:5: ( PASSIVE )?
                    alt39 = 2
                    LA39_0 = self.input.LA(1)

                    if (LA39_0 == PASSIVE) :
                        alt39 = 1
                    if alt39 == 1:
                        # SlimWalkerIdentCheck.g:586:6: PASSIVE
                        pass 
                        self.match(self.input, PASSIVE, self.FOLLOW_PASSIVE_in_portConnection1762)
                        if self._state.backtracking == 0:
                            passive = True 




                    if self._state.backtracking == 0:
                             
                        if self.declaration_stack[-1].the_component:
                        	self.declaration_stack[-1].the_component.add_event_port_connection(
                        	((fromPort is not None) and [fromPort.name] or [None])[0], ((toPort is not None) and [toPort.name] or [None])[0], in_modes, passive,
                        	fromPort.start.line,
                        	fromPort.start.charPositionInLine + 1)
                        				


                    self.match(self.input, UP, None)


                elif alt41 == 2:
                    # SlimWalkerIdentCheck.g:596:4: ^( DATA_CONNECTION fromPort= ident toPort= ident (i= ident )* )
                    pass 
                    self.match(self.input, DATA_CONNECTION, self.FOLLOW_DATA_CONNECTION_in_portConnection1788)

                    if self._state.backtracking == 0:
                           
                        in_modes = []
                        		


                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_portConnection1807)
                    fromPort = self.ident()

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_ident_in_portConnection1821)
                    toPort = self.ident()

                    self._state.following.pop()
                    # SlimWalkerIdentCheck.g:606:5: (i= ident )*
                    while True: #loop40
                        alt40 = 2
                        LA40_0 = self.input.LA(1)

                        if ((NAME <= LA40_0 <= FQ_NAME_OR_IDENT) or LA40_0 == IDENT) :
                            alt40 = 1


                        if alt40 == 1:
                            # SlimWalkerIdentCheck.g:606:6: i= ident
                            pass 
                            self._state.following.append(self.FOLLOW_ident_in_portConnection1836)
                            i = self.ident()

                            self._state.following.pop()
                            if self._state.backtracking == 0:
                                in_modes.append(((i is not None) and [i.name] or [None])[0]) 



                        else:
                            break #loop40


                    if self._state.backtracking == 0:
                             
                        if self.declaration_stack[-1].the_component:
                        	self.declaration_stack[-1].the_component.add_data_port_connection(
                        	((fromPort is not None) and [fromPort.name] or [None])[0], ((toPort is not None) and [toPort.name] or [None])[0], in_modes,
                        	fromPort.start.line,
                        	fromPort.start.charPositionInLine + 1)			
                        				


                    self.match(self.input, UP, None)



            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return 

    # $ANTLR end "portConnection"


    # $ANTLR start "flow"
    # SlimWalkerIdentCheck.g:618:1: flow : ^( FLOW i= ident e= expr[True] (m= ident )* ) ;
    def flow(self, ):

        i = None

        e = None

        m = None


        try:
            try:
                # SlimWalkerIdentCheck.g:619:2: ( ^( FLOW i= ident e= expr[True] (m= ident )* ) )
                # SlimWalkerIdentCheck.g:619:4: ^( FLOW i= ident e= expr[True] (m= ident )* )
                pass 
                self.match(self.input, FLOW, self.FOLLOW_FLOW_in_flow1869)

                if self._state.backtracking == 0:
                       
                    in_modes = []
                    		


                self.match(self.input, DOWN, None)
                self._state.following.append(self.FOLLOW_ident_in_flow1880)
                i = self.ident()

                self._state.following.pop()
                self._state.following.append(self.FOLLOW_expr_in_flow1887)
                e = self.expr(True)

                self._state.following.pop()
                # SlimWalkerIdentCheck.g:625:4: (m= ident )*
                while True: #loop42
                    alt42 = 2
                    LA42_0 = self.input.LA(1)

                    if ((NAME <= LA42_0 <= FQ_NAME_OR_IDENT) or LA42_0 == IDENT) :
                        alt42 = 1


                    if alt42 == 1:
                        # SlimWalkerIdentCheck.g:625:5: m= ident
                        pass 
                        self._state.following.append(self.FOLLOW_ident_in_flow1896)
                        m = self.ident()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            in_modes.append(((m is not None) and [m.name] or [None])[0]) 



                    else:
                        break #loop42


                if self._state.backtracking == 0:
                       
                    if self.declaration_stack[-1].the_component:
                    	self.declaration_stack[-1].the_component.add_flow(BinaryOperatorTreeNode(
                    											IdentifierTreeNode(((i is not None) and [i.name] or [None])[0], i.start.line, i.start.charPositionInLine + 1),
                    											((e is not None) and [e.value] or [None])[0],
                    											OperatorType.ASSIGN,
                    										 	i.start.line, i.start.charPositionInLine + 1),
                    									in_modes, i.start.line, i.start.charPositionInLine + 1)
                    		


                self.match(self.input, UP, None)




            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return 

    # $ANTLR end "flow"


    # $ANTLR start "mode"
    # SlimWalkerIdentCheck.g:638:1: mode : ( ^( INITIAL i= ident (u= urgent )? (invariant= expr[True] )? ) | ^( ACTIVATION i= ident (u= urgent )? (invariant= expr[True] )? ) | ^( ERROR i= ident (u= urgent )? (invariant= expr[True] )? ) | ^( NORMAL i= ident (u= urgent )? (invariant= expr[True] )? ) );
    def mode(self, ):

        i = None

        u = None

        invariant = None


        try:
            try:
                # SlimWalkerIdentCheck.g:640:2: ( ^( INITIAL i= ident (u= urgent )? (invariant= expr[True] )? ) | ^( ACTIVATION i= ident (u= urgent )? (invariant= expr[True] )? ) | ^( ERROR i= ident (u= urgent )? (invariant= expr[True] )? ) | ^( NORMAL i= ident (u= urgent )? (invariant= expr[True] )? ) )
                alt51 = 4
                LA51 = self.input.LA(1)
                if LA51 == INITIAL:
                    alt51 = 1
                elif LA51 == ACTIVATION:
                    alt51 = 2
                elif LA51 == ERROR:
                    alt51 = 3
                elif LA51 == NORMAL:
                    alt51 = 4
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 51, 0, self.input)

                    raise nvae

                if alt51 == 1:
                    # SlimWalkerIdentCheck.g:640:4: ^( INITIAL i= ident (u= urgent )? (invariant= expr[True] )? )
                    pass 
                    self.match(self.input, INITIAL, self.FOLLOW_INITIAL_in_mode1922)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_mode1935)
                    i = self.ident()

                    self._state.following.pop()
                    # SlimWalkerIdentCheck.g:644:6: (u= urgent )?
                    alt43 = 2
                    LA43_0 = self.input.LA(1)

                    if (LA43_0 == URGENT) :
                        alt43 = 1
                    if alt43 == 1:
                        # SlimWalkerIdentCheck.g:0:0: u= urgent
                        pass 
                        self._state.following.append(self.FOLLOW_urgent_in_mode1948)
                        u = self.urgent()

                        self._state.following.pop()



                    # SlimWalkerIdentCheck.g:646:14: (invariant= expr[True] )?
                    alt44 = 2
                    LA44_0 = self.input.LA(1)

                    if ((AND <= LA44_0 <= CASE) or (NOT <= LA44_0 <= NEQ) or (MSEC <= LA44_0 <= FALSE) or (NAME <= LA44_0 <= FQ_NAME_OR_IDENT) or (TRAJ_EXPR <= LA44_0 <= UNARY_MINUS) or (IDENT <= LA44_0 <= NUMBER)) :
                        alt44 = 1
                    if alt44 == 1:
                        # SlimWalkerIdentCheck.g:0:0: invariant= expr[True]
                        pass 
                        self._state.following.append(self.FOLLOW_expr_in_mode1962)
                        invariant = self.expr(True)

                        self._state.following.pop()



                    if self._state.backtracking == 0:
                             
                        if self.declaration_stack[-1].the_component:
                        	self.declaration_stack[-1].the_component.add_initial_mode(
                        			((i is not None) and [i.name] or [None])[0], ((invariant is not None) and [invariant.value] or [None])[0], u, i.start.line,
                        			i.start.charPositionInLine + 1)
                        				


                    self.match(self.input, UP, None)


                elif alt51 == 2:
                    # SlimWalkerIdentCheck.g:657:4: ^( ACTIVATION i= ident (u= urgent )? (invariant= expr[True] )? )
                    pass 
                    self.match(self.input, ACTIVATION, self.FOLLOW_ACTIVATION_in_mode1991)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_mode2005)
                    i = self.ident()

                    self._state.following.pop()
                    # SlimWalkerIdentCheck.g:661:6: (u= urgent )?
                    alt45 = 2
                    LA45_0 = self.input.LA(1)

                    if (LA45_0 == URGENT) :
                        alt45 = 1
                    if alt45 == 1:
                        # SlimWalkerIdentCheck.g:0:0: u= urgent
                        pass 
                        self._state.following.append(self.FOLLOW_urgent_in_mode2019)
                        u = self.urgent()

                        self._state.following.pop()



                    # SlimWalkerIdentCheck.g:663:14: (invariant= expr[True] )?
                    alt46 = 2
                    LA46_0 = self.input.LA(1)

                    if ((AND <= LA46_0 <= CASE) or (NOT <= LA46_0 <= NEQ) or (MSEC <= LA46_0 <= FALSE) or (NAME <= LA46_0 <= FQ_NAME_OR_IDENT) or (TRAJ_EXPR <= LA46_0 <= UNARY_MINUS) or (IDENT <= LA46_0 <= NUMBER)) :
                        alt46 = 1
                    if alt46 == 1:
                        # SlimWalkerIdentCheck.g:0:0: invariant= expr[True]
                        pass 
                        self._state.following.append(self.FOLLOW_expr_in_mode2033)
                        invariant = self.expr(True)

                        self._state.following.pop()



                    if self._state.backtracking == 0:
                             
                        if self.declaration_stack[-1].the_component:
                        	self.declaration_stack[-1].the_component.add_activation_mode(
                        			((i is not None) and [i.name] or [None])[0], ((invariant is not None) and [invariant.value] or [None])[0], u, i.start.line,
                        			i.start.charPositionInLine + 1)
                        				


                    self.match(self.input, UP, None)


                elif alt51 == 3:
                    # SlimWalkerIdentCheck.g:672:4: ^( ERROR i= ident (u= urgent )? (invariant= expr[True] )? )
                    pass 
                    self.match(self.input, ERROR, self.FOLLOW_ERROR_in_mode2056)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_mode2069)
                    i = self.ident()

                    self._state.following.pop()
                    # SlimWalkerIdentCheck.g:676:6: (u= urgent )?
                    alt47 = 2
                    LA47_0 = self.input.LA(1)

                    if (LA47_0 == URGENT) :
                        alt47 = 1
                    if alt47 == 1:
                        # SlimWalkerIdentCheck.g:0:0: u= urgent
                        pass 
                        self._state.following.append(self.FOLLOW_urgent_in_mode2082)
                        u = self.urgent()

                        self._state.following.pop()



                    # SlimWalkerIdentCheck.g:678:14: (invariant= expr[True] )?
                    alt48 = 2
                    LA48_0 = self.input.LA(1)

                    if ((AND <= LA48_0 <= CASE) or (NOT <= LA48_0 <= NEQ) or (MSEC <= LA48_0 <= FALSE) or (NAME <= LA48_0 <= FQ_NAME_OR_IDENT) or (TRAJ_EXPR <= LA48_0 <= UNARY_MINUS) or (IDENT <= LA48_0 <= NUMBER)) :
                        alt48 = 1
                    if alt48 == 1:
                        # SlimWalkerIdentCheck.g:0:0: invariant= expr[True]
                        pass 
                        self._state.following.append(self.FOLLOW_expr_in_mode2096)
                        invariant = self.expr(True)

                        self._state.following.pop()



                    if self._state.backtracking == 0:
                             
                        if self.declaration_stack[-1].the_component:
                        	self.declaration_stack[-1].the_component.add_error_mode(
                        			((i is not None) and [i.name] or [None])[0], ((invariant is not None) and [invariant.value] or [None])[0], u, i.start.line,
                        			i.start.charPositionInLine + 1)
                        	
                        	self.declaration_stack[-1].the_component.is_error_component_implementation = True
                        				


                    self.match(self.input, UP, None)


                elif alt51 == 4:
                    # SlimWalkerIdentCheck.g:691:4: ^( NORMAL i= ident (u= urgent )? (invariant= expr[True] )? )
                    pass 
                    self.match(self.input, NORMAL, self.FOLLOW_NORMAL_in_mode2121)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_mode2135)
                    i = self.ident()

                    self._state.following.pop()
                    # SlimWalkerIdentCheck.g:695:6: (u= urgent )?
                    alt49 = 2
                    LA49_0 = self.input.LA(1)

                    if (LA49_0 == URGENT) :
                        alt49 = 1
                    if alt49 == 1:
                        # SlimWalkerIdentCheck.g:0:0: u= urgent
                        pass 
                        self._state.following.append(self.FOLLOW_urgent_in_mode2148)
                        u = self.urgent()

                        self._state.following.pop()



                    # SlimWalkerIdentCheck.g:697:14: (invariant= expr[True] )?
                    alt50 = 2
                    LA50_0 = self.input.LA(1)

                    if ((AND <= LA50_0 <= CASE) or (NOT <= LA50_0 <= NEQ) or (MSEC <= LA50_0 <= FALSE) or (NAME <= LA50_0 <= FQ_NAME_OR_IDENT) or (TRAJ_EXPR <= LA50_0 <= UNARY_MINUS) or (IDENT <= LA50_0 <= NUMBER)) :
                        alt50 = 1
                    if alt50 == 1:
                        # SlimWalkerIdentCheck.g:0:0: invariant= expr[True]
                        pass 
                        self._state.following.append(self.FOLLOW_expr_in_mode2166)
                        invariant = self.expr(True)

                        self._state.following.pop()



                    if self._state.backtracking == 0:
                             
                        if self.declaration_stack[-1].the_component:
                        	self.declaration_stack[-1].the_component.add_mode(
                        			((i is not None) and [i.name] or [None])[0], ((invariant is not None) and [invariant.value] or [None])[0], u, i.start.line,
                        			i.start.charPositionInLine + 1)
                        				


                    self.match(self.input, UP, None)



            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return 

    # $ANTLR end "mode"


    # $ANTLR start "urgent"
    # SlimWalkerIdentCheck.g:708:1: urgent returns [value] : ^( URGENT bound= expr[True] ) ;
    def urgent(self, ):

        value = None

        bound = None


        try:
            try:
                # SlimWalkerIdentCheck.g:709:2: ( ^( URGENT bound= expr[True] ) )
                # SlimWalkerIdentCheck.g:709:4: ^( URGENT bound= expr[True] )
                pass 
                self.match(self.input, URGENT, self.FOLLOW_URGENT_in_urgent2197)

                self.match(self.input, DOWN, None)
                self._state.following.append(self.FOLLOW_expr_in_urgent2201)
                bound = self.expr(True)

                self._state.following.pop()
                if self._state.backtracking == 0:
                       
                    value = ((bound is not None) and [bound.value] or [None])[0]
                    		


                self.match(self.input, UP, None)




            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return value

    # $ANTLR end "urgent"

    class expr_return(TreeRuleReturnScope):
        def __init__(self):
            TreeRuleReturnScope.__init__(self)

            self.value = None




    # $ANTLR start "expr"
    # SlimWalkerIdentCheck.g:716:1: expr[evaluate] returns [value] : ( ^( NOT exp= expr[evaluate] ) | ^( IMP lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( IFF lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( XNOR lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( OR lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( AND lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( XOR lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( EQ lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( NEQ lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( LT lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( LE lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( GT lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( GE lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( PLUS lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( MINUS lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( TIMES lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( DIVIDE lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( MOD lexp= expr[evaluate] rexp= expr[evaluate] ) | ^(c= CASE (lexp= expr[evaluate] rexp= expr[evaluate] )+ OTHERWISE default= expr[evaluate] ) | ^( DERIVATIVE i= ident trajExpr= expr[evaluate] ( PER ts= timeScaleUnit )? ) | ^( TRAJ_EXPR n= NUMBER ) | n= TRUE | n= FALSE | n= NUMBER | i= ident | ^( NAME i1= ident i2= ident ) | ^( UNARY_MINUS e= expr[evaluate] ) | e= timeScaleOperator[evaluate] );
    def expr(self, evaluate):

        retval = self.expr_return()
        retval.start = self.input.LT(1)

        c = None
        n = None
        exp = None

        lexp = None

        rexp = None

        default = None

        i = None

        trajExpr = None

        ts = None

        i1 = None

        i2 = None

        e = None


        try:
            try:
                # SlimWalkerIdentCheck.g:717:2: ( ^( NOT exp= expr[evaluate] ) | ^( IMP lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( IFF lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( XNOR lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( OR lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( AND lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( XOR lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( EQ lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( NEQ lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( LT lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( LE lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( GT lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( GE lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( PLUS lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( MINUS lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( TIMES lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( DIVIDE lexp= expr[evaluate] rexp= expr[evaluate] ) | ^( MOD lexp= expr[evaluate] rexp= expr[evaluate] ) | ^(c= CASE (lexp= expr[evaluate] rexp= expr[evaluate] )+ OTHERWISE default= expr[evaluate] ) | ^( DERIVATIVE i= ident trajExpr= expr[evaluate] ( PER ts= timeScaleUnit )? ) | ^( TRAJ_EXPR n= NUMBER ) | n= TRUE | n= FALSE | n= NUMBER | i= ident | ^( NAME i1= ident i2= ident ) | ^( UNARY_MINUS e= expr[evaluate] ) | e= timeScaleOperator[evaluate] )
                alt54 = 28
                alt54 = self.dfa54.predict(self.input)
                if alt54 == 1:
                    # SlimWalkerIdentCheck.g:717:4: ^( NOT exp= expr[evaluate] )
                    pass 
                    self.match(self.input, NOT, self.FOLLOW_NOT_in_expr2226)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_expr2230)
                    exp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = "not " + ((exp is not None) and [exp.value] or [None])[0]
                        else:
                        	retval.value = UnaryOperatorTreeNode(((exp is not None) and [exp.value] or [None])[0], OperatorType.NOT,
                        								   exp.start.line,
                        						 		   exp.start.charPositionInLine + 1) 
                        		



                elif alt54 == 2:
                    # SlimWalkerIdentCheck.g:726:4: ^( IMP lexp= expr[evaluate] rexp= expr[evaluate] )
                    pass 
                    self.match(self.input, IMP, self.FOLLOW_IMP_in_expr2242)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_expr2246)
                    lexp = self.expr(evaluate)

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_expr_in_expr2251)
                    rexp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = ((lexp is not None) and [lexp.value] or [None])[0] + " imp " + ((rexp is not None) and [rexp.value] or [None])[0]
                        else:
                        	retval.value = BinaryOperatorTreeNode(((lexp is not None) and [lexp.value] or [None])[0], ((rexp is not None) and [rexp.value] or [None])[0],
                        							  OperatorType.IMP, lexp.start.line,
                        							  lexp.start.charPositionInLine + 1)
                        		



                elif alt54 == 3:
                    # SlimWalkerIdentCheck.g:735:4: ^( IFF lexp= expr[evaluate] rexp= expr[evaluate] )
                    pass 
                    self.match(self.input, IFF, self.FOLLOW_IFF_in_expr2263)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_expr2267)
                    lexp = self.expr(evaluate)

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_expr_in_expr2272)
                    rexp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = ((lexp is not None) and [lexp.value] or [None])[0] + " iff " + ((rexp is not None) and [rexp.value] or [None])[0]
                        else:
                        	retval.value = BinaryOperatorTreeNode(((lexp is not None) and [lexp.value] or [None])[0], ((rexp is not None) and [rexp.value] or [None])[0],
                        							  OperatorType.IFF, lexp.start.line,
                        							  lexp.start.charPositionInLine + 1)
                        		



                elif alt54 == 4:
                    # SlimWalkerIdentCheck.g:744:4: ^( XNOR lexp= expr[evaluate] rexp= expr[evaluate] )
                    pass 
                    self.match(self.input, XNOR, self.FOLLOW_XNOR_in_expr2284)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_expr2288)
                    lexp = self.expr(evaluate)

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_expr_in_expr2293)
                    rexp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = ((lexp is not None) and [lexp.value] or [None])[0] + " xnor " + ((rexp is not None) and [rexp.value] or [None])[0]
                        else:
                        	retval.value = BinaryOperatorTreeNode(((lexp is not None) and [lexp.value] or [None])[0], ((rexp is not None) and [rexp.value] or [None])[0],
                        							  OperatorType.XNOR, lexp.start.line,
                        							  lexp.start.charPositionInLine + 1)
                        		



                elif alt54 == 5:
                    # SlimWalkerIdentCheck.g:753:4: ^( OR lexp= expr[evaluate] rexp= expr[evaluate] )
                    pass 
                    self.match(self.input, OR, self.FOLLOW_OR_in_expr2305)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_expr2309)
                    lexp = self.expr(evaluate)

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_expr_in_expr2314)
                    rexp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = ((lexp is not None) and [lexp.value] or [None])[0] + " or " + ((rexp is not None) and [rexp.value] or [None])[0]
                        else:
                        	retval.value = BinaryOperatorTreeNode(((lexp is not None) and [lexp.value] or [None])[0], ((rexp is not None) and [rexp.value] or [None])[0],
                        							  OperatorType.OR, lexp.start.line,
                        							  lexp.start.charPositionInLine + 1)		
                        		



                elif alt54 == 6:
                    # SlimWalkerIdentCheck.g:762:4: ^( AND lexp= expr[evaluate] rexp= expr[evaluate] )
                    pass 
                    self.match(self.input, AND, self.FOLLOW_AND_in_expr2326)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_expr2330)
                    lexp = self.expr(evaluate)

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_expr_in_expr2335)
                    rexp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = ((lexp is not None) and [lexp.value] or [None])[0] + " and " + ((rexp is not None) and [rexp.value] or [None])[0]
                        else:
                        	retval.value = BinaryOperatorTreeNode(((lexp is not None) and [lexp.value] or [None])[0], ((rexp is not None) and [rexp.value] or [None])[0],
                        							  OperatorType.AND, lexp.start.line,
                        							  lexp.start.charPositionInLine + 1)
                        		



                elif alt54 == 7:
                    # SlimWalkerIdentCheck.g:771:4: ^( XOR lexp= expr[evaluate] rexp= expr[evaluate] )
                    pass 
                    self.match(self.input, XOR, self.FOLLOW_XOR_in_expr2347)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_expr2351)
                    lexp = self.expr(evaluate)

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_expr_in_expr2356)
                    rexp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = ((lexp is not None) and [lexp.value] or [None])[0] + " xor " + ((rexp is not None) and [rexp.value] or [None])[0]
                        else:
                        	retval.value = BinaryOperatorTreeNode(((lexp is not None) and [lexp.value] or [None])[0], ((rexp is not None) and [rexp.value] or [None])[0],
                        							  OperatorType.XOR, lexp.start.line,
                        							  lexp.start.charPositionInLine + 1)
                        		



                elif alt54 == 8:
                    # SlimWalkerIdentCheck.g:780:4: ^( EQ lexp= expr[evaluate] rexp= expr[evaluate] )
                    pass 
                    self.match(self.input, EQ, self.FOLLOW_EQ_in_expr2368)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_expr2372)
                    lexp = self.expr(evaluate)

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_expr_in_expr2377)
                    rexp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = ((lexp is not None) and [lexp.value] or [None])[0] + " == " + ((rexp is not None) and [rexp.value] or [None])[0]
                        else:
                        	retval.value = BinaryOperatorTreeNode(((lexp is not None) and [lexp.value] or [None])[0], ((rexp is not None) and [rexp.value] or [None])[0],
                        							  OperatorType.EQUAL,
                        							  lexp.start.line,
                        							  lexp.start.charPositionInLine + 1)
                        		



                elif alt54 == 9:
                    # SlimWalkerIdentCheck.g:790:4: ^( NEQ lexp= expr[evaluate] rexp= expr[evaluate] )
                    pass 
                    self.match(self.input, NEQ, self.FOLLOW_NEQ_in_expr2389)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_expr2393)
                    lexp = self.expr(evaluate)

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_expr_in_expr2398)
                    rexp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = ((lexp is not None) and [lexp.value] or [None])[0] + " != " + ((rexp is not None) and [rexp.value] or [None])[0]
                        else:
                        	retval.value = BinaryOperatorTreeNode(((lexp is not None) and [lexp.value] or [None])[0], ((rexp is not None) and [rexp.value] or [None])[0],
                        							  OperatorType.NOTEQUAL,
                        							  lexp.start.line,
                        							  lexp.start.charPositionInLine + 1)
                        		



                elif alt54 == 10:
                    # SlimWalkerIdentCheck.g:800:4: ^( LT lexp= expr[evaluate] rexp= expr[evaluate] )
                    pass 
                    self.match(self.input, LT, self.FOLLOW_LT_in_expr2410)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_expr2414)
                    lexp = self.expr(evaluate)

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_expr_in_expr2419)
                    rexp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = ((lexp is not None) and [lexp.value] or [None])[0] + " < " + ((rexp is not None) and [rexp.value] or [None])[0]
                        else:
                        	retval.value = BinaryOperatorTreeNode(((lexp is not None) and [lexp.value] or [None])[0], ((rexp is not None) and [rexp.value] or [None])[0],
                        							  OperatorType.LESS, lexp.start.line,
                        							  lexp.start.charPositionInLine + 1)
                        		



                elif alt54 == 11:
                    # SlimWalkerIdentCheck.g:809:4: ^( LE lexp= expr[evaluate] rexp= expr[evaluate] )
                    pass 
                    self.match(self.input, LE, self.FOLLOW_LE_in_expr2431)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_expr2435)
                    lexp = self.expr(evaluate)

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_expr_in_expr2440)
                    rexp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = ((lexp is not None) and [lexp.value] or [None])[0] + " <= " + ((rexp is not None) and [rexp.value] or [None])[0]
                        else:
                        	retval.value = BinaryOperatorTreeNode(((lexp is not None) and [lexp.value] or [None])[0], ((rexp is not None) and [rexp.value] or [None])[0],
                        							  OperatorType.LESSOREQUAL,
                        							  lexp.start.line,
                        							  lexp.start.charPositionInLine + 1)
                        		



                elif alt54 == 12:
                    # SlimWalkerIdentCheck.g:819:4: ^( GT lexp= expr[evaluate] rexp= expr[evaluate] )
                    pass 
                    self.match(self.input, GT, self.FOLLOW_GT_in_expr2452)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_expr2456)
                    lexp = self.expr(evaluate)

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_expr_in_expr2461)
                    rexp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = ((lexp is not None) and [lexp.value] or [None])[0] + " > " + ((rexp is not None) and [rexp.value] or [None])[0]
                        else:
                        	retval.value = BinaryOperatorTreeNode(((lexp is not None) and [lexp.value] or [None])[0], ((rexp is not None) and [rexp.value] or [None])[0],
                        							  OperatorType.GREATER,
                        							  lexp.start.line,
                        							  lexp.start.charPositionInLine + 1)
                        		



                elif alt54 == 13:
                    # SlimWalkerIdentCheck.g:829:4: ^( GE lexp= expr[evaluate] rexp= expr[evaluate] )
                    pass 
                    self.match(self.input, GE, self.FOLLOW_GE_in_expr2473)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_expr2477)
                    lexp = self.expr(evaluate)

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_expr_in_expr2482)
                    rexp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = ((lexp is not None) and [lexp.value] or [None])[0] + " >= " + ((rexp is not None) and [rexp.value] or [None])[0]
                        else:
                        	retval.value = BinaryOperatorTreeNode(((lexp is not None) and [lexp.value] or [None])[0], ((rexp is not None) and [rexp.value] or [None])[0],
                        							  OperatorType.GREATEROREQUAL,
                        							  lexp.start.line,
                        							  lexp.start.charPositionInLine + 1)
                        		



                elif alt54 == 14:
                    # SlimWalkerIdentCheck.g:839:4: ^( PLUS lexp= expr[evaluate] rexp= expr[evaluate] )
                    pass 
                    self.match(self.input, PLUS, self.FOLLOW_PLUS_in_expr2494)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_expr2498)
                    lexp = self.expr(evaluate)

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_expr_in_expr2503)
                    rexp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = ((lexp is not None) and [lexp.value] or [None])[0] + " + " + ((rexp is not None) and [rexp.value] or [None])[0]
                        else:
                        	retval.value = BinaryOperatorTreeNode(((lexp is not None) and [lexp.value] or [None])[0], ((rexp is not None) and [rexp.value] or [None])[0],
                        							  OperatorType.PLUS,
                        							  lexp.start.line,
                        							  lexp.start.charPositionInLine + 1)
                        		



                elif alt54 == 15:
                    # SlimWalkerIdentCheck.g:849:4: ^( MINUS lexp= expr[evaluate] rexp= expr[evaluate] )
                    pass 
                    self.match(self.input, MINUS, self.FOLLOW_MINUS_in_expr2515)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_expr2519)
                    lexp = self.expr(evaluate)

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_expr_in_expr2524)
                    rexp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = ((lexp is not None) and [lexp.value] or [None])[0] + " - " + ((rexp is not None) and [rexp.value] or [None])[0]
                        else:
                        	retval.value = BinaryOperatorTreeNode(((lexp is not None) and [lexp.value] or [None])[0], ((rexp is not None) and [rexp.value] or [None])[0],
                        							  OperatorType.MINUS,
                        							  lexp.start.line,
                        							  lexp.start.charPositionInLine + 1)
                        		



                elif alt54 == 16:
                    # SlimWalkerIdentCheck.g:859:4: ^( TIMES lexp= expr[evaluate] rexp= expr[evaluate] )
                    pass 
                    self.match(self.input, TIMES, self.FOLLOW_TIMES_in_expr2536)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_expr2540)
                    lexp = self.expr(evaluate)

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_expr_in_expr2545)
                    rexp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = ((lexp is not None) and [lexp.value] or [None])[0] + " * " + ((rexp is not None) and [rexp.value] or [None])[0]
                        else:
                        	retval.value = BinaryOperatorTreeNode(((lexp is not None) and [lexp.value] or [None])[0], ((rexp is not None) and [rexp.value] or [None])[0],
                        							  OperatorType.TIMES,
                        							  lexp.start.line,
                        							  lexp.start.charPositionInLine + 1)
                        		



                elif alt54 == 17:
                    # SlimWalkerIdentCheck.g:869:4: ^( DIVIDE lexp= expr[evaluate] rexp= expr[evaluate] )
                    pass 
                    self.match(self.input, DIVIDE, self.FOLLOW_DIVIDE_in_expr2557)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_expr2561)
                    lexp = self.expr(evaluate)

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_expr_in_expr2566)
                    rexp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = ((lexp is not None) and [lexp.value] or [None])[0] + " / " + ((rexp is not None) and [rexp.value] or [None])[0]
                        else:
                        	retval.value = BinaryOperatorTreeNode(((lexp is not None) and [lexp.value] or [None])[0], ((rexp is not None) and [rexp.value] or [None])[0],
                        							  OperatorType.DIVIDE,
                        							  lexp.start.line,
                        							  lexp.start.charPositionInLine + 1)
                        		



                elif alt54 == 18:
                    # SlimWalkerIdentCheck.g:879:5: ^( MOD lexp= expr[evaluate] rexp= expr[evaluate] )
                    pass 
                    self.match(self.input, MOD, self.FOLLOW_MOD_in_expr2579)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_expr2583)
                    lexp = self.expr(evaluate)

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_expr_in_expr2588)
                    rexp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                               	retval.value = ((lexp is not None) and [lexp.value] or [None])[0] + " mod " + ((rexp is not None) and [rexp.value] or [None])[0]
                        else:
                               	retval.value = BinaryOperatorTreeNode(((lexp is not None) and [lexp.value] or [None])[0], ((rexp is not None) and [rexp.value] or [None])[0],
                        		OperatorType.MOD,
                        		lexp.start.line,
                        		lexp.start.charPositionInLine + 1)
                        		



                elif alt54 == 19:
                    # SlimWalkerIdentCheck.g:889:4: ^(c= CASE (lexp= expr[evaluate] rexp= expr[evaluate] )+ OTHERWISE default= expr[evaluate] )
                    pass 
                    c=self.match(self.input, CASE, self.FOLLOW_CASE_in_expr2604)

                    if self._state.backtracking == 0:
                           
                        cases = []
                        		


                    self.match(self.input, DOWN, None)
                    # SlimWalkerIdentCheck.g:893:4: (lexp= expr[evaluate] rexp= expr[evaluate] )+
                    cnt52 = 0
                    while True: #loop52
                        alt52 = 2
                        LA52_0 = self.input.LA(1)

                        if ((AND <= LA52_0 <= CASE) or (NOT <= LA52_0 <= NEQ) or (MSEC <= LA52_0 <= FALSE) or (NAME <= LA52_0 <= FQ_NAME_OR_IDENT) or (TRAJ_EXPR <= LA52_0 <= UNARY_MINUS) or (IDENT <= LA52_0 <= NUMBER)) :
                            alt52 = 1


                        if alt52 == 1:
                            # SlimWalkerIdentCheck.g:893:5: lexp= expr[evaluate] rexp= expr[evaluate]
                            pass 
                            self._state.following.append(self.FOLLOW_expr_in_expr2616)
                            lexp = self.expr(evaluate)

                            self._state.following.pop()
                            self._state.following.append(self.FOLLOW_expr_in_expr2621)
                            rexp = self.expr(evaluate)

                            self._state.following.pop()
                            if self._state.backtracking == 0:
                                    
                                cases.append((((lexp is not None) and [lexp.value] or [None])[0], ((rexp is not None) and [rexp.value] or [None])[0]))
                                			



                        else:
                            if cnt52 >= 1:
                                break #loop52

                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            eee = EarlyExitException(52, self.input)
                            raise eee

                        cnt52 += 1


                    self.match(self.input, OTHERWISE, self.FOLLOW_OTHERWISE_in_expr2639)
                    self._state.following.append(self.FOLLOW_expr_in_expr2647)
                    default = self.expr(evaluate)

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value =  "case "
                        	for (cond, res) in cases:
                        		retval.value += cond + " : " + res + " "
                        		retval.value += "otherwise : " + ((default is not None) and [default.value] or [None])[0]
                        		retval.value += " end"
                        else:
                        	retval.value = CaseExpressionTreeNode(cases, ((default is not None) and [default.value] or [None])[0],
                        									c.line,
                        									c.charPositionInLine + 1)
                        					
                        		


                    self.match(self.input, UP, None)


                elif alt54 == 20:
                    # SlimWalkerIdentCheck.g:915:4: ^( DERIVATIVE i= ident trajExpr= expr[evaluate] ( PER ts= timeScaleUnit )? )
                    pass 
                    self.match(self.input, DERIVATIVE, self.FOLLOW_DERIVATIVE_in_expr2663)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_expr2677)
                    i = self.ident()

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_expr_in_expr2691)
                    trajExpr = self.expr(evaluate)

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        time_unit=None

                    # SlimWalkerIdentCheck.g:921:5: ( PER ts= timeScaleUnit )?
                    alt53 = 2
                    LA53_0 = self.input.LA(1)

                    if (LA53_0 == PER) :
                        alt53 = 1
                    if alt53 == 1:
                        # SlimWalkerIdentCheck.g:921:6: PER ts= timeScaleUnit
                        pass 
                        self.match(self.input, PER, self.FOLLOW_PER_in_expr2705)
                        self._state.following.append(self.FOLLOW_timeScaleUnit_in_expr2709)
                        ts = self.timeScaleUnit()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            time_unit=ts





                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = ((i is not None) and [i.name] or [None])[0] + "\' = " + ((trajExpr is not None) and [trajExpr.value] or [None])[0]
                        else:
                        	retval.value = TrajectoryEquationTreeNode(
                        				IdentifierTreeNode(((i is not None) and [i.name] or [None])[0], i.start.line,
                        								   i.start.charPositionInLine + 1),
                        				((trajExpr is not None) and [trajExpr.value] or [None])[0], i.start.line,
                        				i.start.charPositionInLine + 1,
                        				time_unit)
                        		



                elif alt54 == 21:
                    # SlimWalkerIdentCheck.g:936:4: ^( TRAJ_EXPR n= NUMBER )
                    pass 
                    self.match(self.input, TRAJ_EXPR, self.FOLLOW_TRAJ_EXPR_in_expr2728)

                    self.match(self.input, DOWN, None)
                    n=self.match(self.input, NUMBER, self.FOLLOW_NUMBER_in_expr2741)

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           	
                        retval.value = TrajectoryExpressionTreeNode(
                        				None,
                        				None, int(n.text), n.start.line,
                        				n.start.charPositionInLine + 1)
                        		



                elif alt54 == 22:
                    # SlimWalkerIdentCheck.g:946:4: n= TRUE
                    pass 
                    n=self.match(self.input, TRUE, self.FOLLOW_TRUE_in_expr2756)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = "true"
                        else:
                        	retval.value = BooleanTreeNode(True, n.line,
                        							 n.charPositionInLine + 1)
                        		



                elif alt54 == 23:
                    # SlimWalkerIdentCheck.g:954:4: n= FALSE
                    pass 
                    n=self.match(self.input, FALSE, self.FOLLOW_FALSE_in_expr2767)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = "false"
                        else:
                        	retval.value = BooleanTreeNode(False, n.line,
                        							 n.charPositionInLine + 1)
                        		



                elif alt54 == 24:
                    # SlimWalkerIdentCheck.g:962:4: n= NUMBER
                    pass 
                    if self._state.backtracking == 0:
                            
                        t = None
                        		

                    n=self.match(self.input, NUMBER, self.FOLLOW_NUMBER_in_expr2782)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = n.text
                        else:
                        	retval.value = NumberTreeNode(n.text, None,
                        							n.line,
                        							n.charPositionInLine + 1) 
                        		



                elif alt54 == 25:
                    # SlimWalkerIdentCheck.g:974:4: i= ident
                    pass 
                    self._state.following.append(self.FOLLOW_ident_in_expr2793)
                    i = self.ident()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = ((i is not None) and [i.name] or [None])[0]
                        else:
                        	retval.value = IdentifierTreeNode(((i is not None) and [i.name] or [None])[0], i.start.line,
                        								i.start.charPositionInLine + 1)
                        		



                elif alt54 == 26:
                    # SlimWalkerIdentCheck.g:982:4: ^( NAME i1= ident i2= ident )
                    pass 
                    self.match(self.input, NAME, self.FOLLOW_NAME_in_expr2803)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_expr2807)
                    i1 = self.ident()

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_ident_in_expr2811)
                    i2 = self.ident()

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = ((i1 is not None) and [i1.name] or [None])[0] + "." + ((i2 is not None) and [i2.name] or [None])[0]
                        else:
                        	retval.value = IdentifierTreeNode(((i1 is not None) and [i1.name] or [None])[0] + "." + ((i2 is not None) and [i2.name] or [None])[0],
                        								i1.start.line,
                        								i.start.charPositionInLine + 1)
                        		



                elif alt54 == 27:
                    # SlimWalkerIdentCheck.g:991:4: ^( UNARY_MINUS e= expr[evaluate] )
                    pass 
                    self.match(self.input, UNARY_MINUS, self.FOLLOW_UNARY_MINUS_in_expr2822)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_expr2826)
                    e = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                           
                        if not evaluate:
                        	retval.value = "-" + ((i1 is not None) and [i1.name] or [None])[0]
                        else:
                        	retval.value = UnaryOperatorTreeNode(
                        					((e is not None) and [e.value] or [None])[0],
                        					OperatorType.UNARY_MINUS,
                        					e.start.line,
                        					e.start.charPositionInLine + 1)
                        		



                elif alt54 == 28:
                    # SlimWalkerIdentCheck.g:1002:4: e= timeScaleOperator[evaluate]
                    pass 
                    self._state.following.append(self.FOLLOW_timeScaleOperator_in_expr2839)
                    e = self.timeScaleOperator(evaluate)

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                           
                        retval.value = ((e is not None) and [e.value] or [None])[0]
                        		




            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return retval

    # $ANTLR end "expr"

    class timeScaleOperator_return(TreeRuleReturnScope):
        def __init__(self):
            TreeRuleReturnScope.__init__(self)

            self.value = None




    # $ANTLR start "timeScaleOperator"
    # SlimWalkerIdentCheck.g:1008:1: timeScaleOperator[evaluate] returns [value] : ( ^(i= MSEC exp= expr[evaluate] ) | ^(i= SEC exp= expr[evaluate] ) | ^(i= MIN exp= expr[evaluate] ) | ^(i= HOUR exp= expr[evaluate] ) | ^(i= DAY exp= expr[evaluate] ) );
    def timeScaleOperator(self, evaluate):

        retval = self.timeScaleOperator_return()
        retval.start = self.input.LT(1)

        i = None
        exp = None


        try:
            try:
                # SlimWalkerIdentCheck.g:1009:2: ( ^(i= MSEC exp= expr[evaluate] ) | ^(i= SEC exp= expr[evaluate] ) | ^(i= MIN exp= expr[evaluate] ) | ^(i= HOUR exp= expr[evaluate] ) | ^(i= DAY exp= expr[evaluate] ) )
                alt55 = 5
                LA55 = self.input.LA(1)
                if LA55 == MSEC:
                    alt55 = 1
                elif LA55 == SEC:
                    alt55 = 2
                elif LA55 == MIN:
                    alt55 = 3
                elif LA55 == HOUR:
                    alt55 = 4
                elif LA55 == DAY:
                    alt55 = 5
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 55, 0, self.input)

                    raise nvae

                if alt55 == 1:
                    # SlimWalkerIdentCheck.g:1009:4: ^(i= MSEC exp= expr[evaluate] )
                    pass 
                    i=self.match(self.input, MSEC, self.FOLLOW_MSEC_in_timeScaleOperator2864)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_timeScaleOperator2868)
                    exp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                          
                        if not evaluate:
                        	retval.value = ((exp is not None) and [exp.value] or [None])[0] + " msec"
                        else:
                        	retval.value = UnaryOperatorTreeNode(((exp is not None) and [exp.value] or [None])[0], OperatorType.MSEC,
                        	                               i.token.line,
                        	                               i.token.charPositionInLine + 1)
                        	



                elif alt55 == 2:
                    # SlimWalkerIdentCheck.g:1018:4: ^(i= SEC exp= expr[evaluate] )
                    pass 
                    i=self.match(self.input, SEC, self.FOLLOW_SEC_in_timeScaleOperator2881)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_timeScaleOperator2885)
                    exp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                          
                        if not evaluate:
                        	retval.value = ((exp is not None) and [exp.value] or [None])[0] + " sec"
                        else:
                        	retval.value = UnaryOperatorTreeNode(((exp is not None) and [exp.value] or [None])[0], OperatorType.SEC,
                        	                               i.token.line,
                        	                               i.token.charPositionInLine + 1)
                        	



                elif alt55 == 3:
                    # SlimWalkerIdentCheck.g:1027:4: ^(i= MIN exp= expr[evaluate] )
                    pass 
                    i=self.match(self.input, MIN, self.FOLLOW_MIN_in_timeScaleOperator2898)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_timeScaleOperator2902)
                    exp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                          
                        if not evaluate:
                        	retval.value = ((exp is not None) and [exp.value] or [None])[0] + " min"
                        else:
                        	retval.value = UnaryOperatorTreeNode(((exp is not None) and [exp.value] or [None])[0], OperatorType.MIN,
                        	                               i.token.line,
                        	                               i.token.charPositionInLine + 1)
                        	



                elif alt55 == 4:
                    # SlimWalkerIdentCheck.g:1036:4: ^(i= HOUR exp= expr[evaluate] )
                    pass 
                    i=self.match(self.input, HOUR, self.FOLLOW_HOUR_in_timeScaleOperator2915)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_timeScaleOperator2919)
                    exp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                          
                        if not evaluate:
                        	retval.value = ((exp is not None) and [exp.value] or [None])[0] + " hour"
                        else:
                        	retval.value = UnaryOperatorTreeNode(((exp is not None) and [exp.value] or [None])[0], OperatorType.HOUR,
                        	                               i.token.line,
                        	                               i.token.charPositionInLine + 1)
                        	



                elif alt55 == 5:
                    # SlimWalkerIdentCheck.g:1045:4: ^(i= DAY exp= expr[evaluate] )
                    pass 
                    i=self.match(self.input, DAY, self.FOLLOW_DAY_in_timeScaleOperator2932)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_expr_in_timeScaleOperator2936)
                    exp = self.expr(evaluate)

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                          
                        if not evaluate:
                        	retval.value = ((exp is not None) and [exp.value] or [None])[0] + " day"
                        else:
                        	retval.value = UnaryOperatorTreeNode(((exp is not None) and [exp.value] or [None])[0], OperatorType.DAY,
                        	                               i.token.line,
                        	                               i.token.charPositionInLine + 1)
                        	




            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return retval

    # $ANTLR end "timeScaleOperator"

    class sourceMode_return(TreeRuleReturnScope):
        def __init__(self):
            TreeRuleReturnScope.__init__(self)

            self.value = None




    # $ANTLR start "sourceMode"
    # SlimWalkerIdentCheck.g:1056:1: sourceMode returns [value] : ( TIMES | i= ident );
    def sourceMode(self, ):

        retval = self.sourceMode_return()
        retval.start = self.input.LT(1)

        i = None


        try:
            try:
                # SlimWalkerIdentCheck.g:1057:2: ( TIMES | i= ident )
                alt56 = 2
                LA56_0 = self.input.LA(1)

                if (LA56_0 == TIMES) :
                    alt56 = 1
                elif ((NAME <= LA56_0 <= FQ_NAME_OR_IDENT) or LA56_0 == IDENT) :
                    alt56 = 2
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 56, 0, self.input)

                    raise nvae

                if alt56 == 1:
                    # SlimWalkerIdentCheck.g:1057:6: TIMES
                    pass 
                    self.match(self.input, TIMES, self.FOLLOW_TIMES_in_sourceMode2958)
                    if self._state.backtracking == 0:
                           
                        retval.value = "*"
                        		



                elif alt56 == 2:
                    # SlimWalkerIdentCheck.g:1061:9: i= ident
                    pass 
                    self._state.following.append(self.FOLLOW_ident_in_sourceMode2974)
                    i = self.ident()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                              
                        retval.value = ((i is not None) and [i.name] or [None])[0] 
                        		




            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return retval

    # $ANTLR end "sourceMode"


    # $ANTLR start "modeTransition"
    # SlimWalkerIdentCheck.g:1068:1: modeTransition : ( ^( MODE_TRANS fMode= sourceMode toMode= ident (triggers= modeTrigger )? ( WHEN guard= modeGuard )? ( WITHIN lower= expr[True] upper= expr[True] )? ( THEN (effect= modeEffect )+ )? ) | ^( MODE_TRANS_PROB fromMode= ident toMode= ident prob= expr[True] ) );
    def modeTransition(self, ):

        fMode = None

        toMode = None

        triggers = None

        guard = None

        lower = None

        upper = None

        effect = None

        fromMode = None

        prob = None


        try:
            try:
                # SlimWalkerIdentCheck.g:1069:2: ( ^( MODE_TRANS fMode= sourceMode toMode= ident (triggers= modeTrigger )? ( WHEN guard= modeGuard )? ( WITHIN lower= expr[True] upper= expr[True] )? ( THEN (effect= modeEffect )+ )? ) | ^( MODE_TRANS_PROB fromMode= ident toMode= ident prob= expr[True] ) )
                alt62 = 2
                LA62_0 = self.input.LA(1)

                if (LA62_0 == MODE_TRANS) :
                    alt62 = 1
                elif (LA62_0 == MODE_TRANS_PROB) :
                    alt62 = 2
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 62, 0, self.input)

                    raise nvae

                if alt62 == 1:
                    # SlimWalkerIdentCheck.g:1069:4: ^( MODE_TRANS fMode= sourceMode toMode= ident (triggers= modeTrigger )? ( WHEN guard= modeGuard )? ( WITHIN lower= expr[True] upper= expr[True] )? ( THEN (effect= modeEffect )+ )? )
                    pass 
                    self.match(self.input, MODE_TRANS, self.FOLLOW_MODE_TRANS_in_modeTransition2994)

                    if self._state.backtracking == 0:
                            
                        effects = []
                        guard = None
                        triggers = [None]
                        time_delay = None
                        			


                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_sourceMode_in_modeTransition3013)
                    fMode = self.sourceMode()

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_ident_in_modeTransition3026)
                    toMode = self.ident()

                    self._state.following.pop()
                    # SlimWalkerIdentCheck.g:1081:5: (triggers= modeTrigger )?
                    alt57 = 2
                    LA57_0 = self.input.LA(1)

                    if (LA57_0 == ATACTIVATION or LA57_0 == RESET or LA57_0 == OR or (NAME <= LA57_0 <= FQ_NAME_OR_IDENT) or LA57_0 == IDENT) :
                        alt57 = 1
                    if alt57 == 1:
                        # SlimWalkerIdentCheck.g:1081:6: triggers= modeTrigger
                        pass 
                        self._state.following.append(self.FOLLOW_modeTrigger_in_modeTransition3040)
                        triggers = self.modeTrigger()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            triggers = triggers 




                    # SlimWalkerIdentCheck.g:1082:4: ( WHEN guard= modeGuard )?
                    alt58 = 2
                    LA58_0 = self.input.LA(1)

                    if (LA58_0 == WHEN) :
                        alt58 = 1
                    if alt58 == 1:
                        # SlimWalkerIdentCheck.g:1082:5: WHEN guard= modeGuard
                        pass 
                        self.match(self.input, WHEN, self.FOLLOW_WHEN_in_modeTransition3051)
                        self._state.following.append(self.FOLLOW_modeGuard_in_modeTransition3065)
                        guard = self.modeGuard()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            guard = guard




                    # SlimWalkerIdentCheck.g:1085:4: ( WITHIN lower= expr[True] upper= expr[True] )?
                    alt59 = 2
                    LA59_0 = self.input.LA(1)

                    if (LA59_0 == WITHIN) :
                        alt59 = 1
                    if alt59 == 1:
                        # SlimWalkerIdentCheck.g:1085:5: WITHIN lower= expr[True] upper= expr[True]
                        pass 
                        self.match(self.input, WITHIN, self.FOLLOW_WITHIN_in_modeTransition3076)
                        self._state.following.append(self.FOLLOW_expr_in_modeTransition3084)
                        lower = self.expr(True)

                        self._state.following.pop()
                        self._state.following.append(self.FOLLOW_expr_in_modeTransition3089)
                        upper = self.expr(True)

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            time_delay = (((lower is not None) and [lower.value] or [None])[0], ((upper is not None) and [upper.value] or [None])[0])




                    # SlimWalkerIdentCheck.g:1087:4: ( THEN (effect= modeEffect )+ )?
                    alt61 = 2
                    LA61_0 = self.input.LA(1)

                    if (LA61_0 == THEN) :
                        alt61 = 1
                    if alt61 == 1:
                        # SlimWalkerIdentCheck.g:1087:5: THEN (effect= modeEffect )+
                        pass 
                        self.match(self.input, THEN, self.FOLLOW_THEN_in_modeTransition3100)
                        # SlimWalkerIdentCheck.g:1089:5: (effect= modeEffect )+
                        cnt60 = 0
                        while True: #loop60
                            alt60 = 2
                            LA60_0 = self.input.LA(1)

                            if (LA60_0 == ASSIGN) :
                                alt60 = 1


                            if alt60 == 1:
                                # SlimWalkerIdentCheck.g:1089:6: effect= modeEffect
                                pass 
                                self._state.following.append(self.FOLLOW_modeEffect_in_modeTransition3115)
                                effect = self.modeEffect()

                                self._state.following.pop()
                                if self._state.backtracking == 0:
                                    effects.append(effect) 



                            else:
                                if cnt60 >= 1:
                                    break #loop60

                                if self._state.backtracking > 0:
                                    raise BacktrackingFailed

                                eee = EarlyExitException(60, self.input)
                                raise eee

                            cnt60 += 1





                    if self._state.backtracking == 0:
                            
                        if self.declaration_stack[-1].the_component:
                            # for trigger in triggers:
                                if triggers[0] == '@activation':
                                    self.declaration_stack[-1].the_component.add_reactivation_mode_transition(
                                        ((fMode is not None) and [fMode.value] or [None])[0], ((toMode is not None) and [toMode.name] or [None])[0],
                                        guard, time_delay, effects, fMode.start.line,
                                        fMode.start.charPositionInLine + 1)
                                else:
                                    self.declaration_stack[-1].the_component.add_normal_mode_transition(
                                        ((fMode is not None) and [fMode.value] or [None])[0], ((toMode is not None) and [toMode.name] or [None])[0], triggers,
                                        guard, time_delay, effects, fMode.start.line,
                                        fMode.start.charPositionInLine + 1)
                        			


                    self.match(self.input, UP, None)


                elif alt62 == 2:
                    # SlimWalkerIdentCheck.g:1107:4: ^( MODE_TRANS_PROB fromMode= ident toMode= ident prob= expr[True] )
                    pass 
                    self.match(self.input, MODE_TRANS_PROB, self.FOLLOW_MODE_TRANS_PROB_in_modeTransition3147)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_modeTransition3160)
                    fromMode = self.ident()

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_ident_in_modeTransition3173)
                    toMode = self.ident()

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_expr_in_modeTransition3186)
                    prob = self.expr(True)

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                            
                        if self.declaration_stack[-1].the_component:
                        	self.declaration_stack[-1].the_component.add_probability_mode_transition(
                        			((fromMode is not None) and [fromMode.name] or [None])[0], ((toMode is not None) and [toMode.name] or [None])[0], ((prob is not None) and [prob.value] or [None])[0],
                        			fromMode.start.line,
                        			fromMode.start.charPositionInLine + 1)
                        			


                    self.match(self.input, UP, None)



            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return 

    # $ANTLR end "modeTransition"


    # $ANTLR start "modeTrigger"
    # SlimWalkerIdentCheck.g:1125:1: modeTrigger returns [value] : (i= ident | ^( OR trig1= modeTrigger trig2= modeTrigger ) | RESET | ATACTIVATION );
    def modeTrigger(self, ):

        value = None

        i = None

        trig1 = None

        trig2 = None


        try:
            try:
                # SlimWalkerIdentCheck.g:1127:2: (i= ident | ^( OR trig1= modeTrigger trig2= modeTrigger ) | RESET | ATACTIVATION )
                alt63 = 4
                LA63 = self.input.LA(1)
                if LA63 == NAME or LA63 == FQ_NAME_OR_IDENT or LA63 == IDENT:
                    alt63 = 1
                elif LA63 == OR:
                    alt63 = 2
                elif LA63 == RESET:
                    alt63 = 3
                elif LA63 == ATACTIVATION:
                    alt63 = 4
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 63, 0, self.input)

                    raise nvae

                if alt63 == 1:
                    # SlimWalkerIdentCheck.g:1127:4: i= ident
                    pass 
                    self._state.following.append(self.FOLLOW_ident_in_modeTrigger3221)
                    i = self.ident()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                           
                        value = [((i is not None) and [i.name] or [None])[0]]
                        		



                elif alt63 == 2:
                    # SlimWalkerIdentCheck.g:1131:6: ^( OR trig1= modeTrigger trig2= modeTrigger )
                    pass 
                    self.match(self.input, OR, self.FOLLOW_OR_in_modeTrigger3233)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_modeTrigger_in_modeTrigger3237)
                    trig1 = self.modeTrigger()

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_modeTrigger_in_modeTrigger3241)
                    trig2 = self.modeTrigger()

                    self._state.following.pop()

                    self.match(self.input, UP, None)
                    if self._state.backtracking == 0:
                              
                        value = trig1 + trig2 
                        	    



                elif alt63 == 3:
                    # SlimWalkerIdentCheck.g:1136:4: RESET
                    pass 
                    self.match(self.input, RESET, self.FOLLOW_RESET_in_modeTrigger3255)
                    if self._state.backtracking == 0:
                           
                        value = ["reset"]
                        		



                elif alt63 == 4:
                    # SlimWalkerIdentCheck.g:1141:4: ATACTIVATION
                    pass 
                    self.match(self.input, ATACTIVATION, self.FOLLOW_ATACTIVATION_in_modeTrigger3265)
                    if self._state.backtracking == 0:
                           
                        value = ["@activation"]
                        		




            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return value

    # $ANTLR end "modeTrigger"


    # $ANTLR start "modeGuard"
    # SlimWalkerIdentCheck.g:1147:1: modeGuard returns [value] : e= expr[True] ;
    def modeGuard(self, ):

        value = None

        e = None


        try:
            try:
                # SlimWalkerIdentCheck.g:1149:2: (e= expr[True] )
                # SlimWalkerIdentCheck.g:1149:4: e= expr[True]
                pass 
                self._state.following.append(self.FOLLOW_expr_in_modeGuard3288)
                e = self.expr(True)

                self._state.following.pop()
                if self._state.backtracking == 0:
                       
                    value = ((e is not None) and [e.value] or [None])[0] 
                    		





            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return value

    # $ANTLR end "modeGuard"


    # $ANTLR start "modeEffect"
    # SlimWalkerIdentCheck.g:1155:1: modeEffect returns [value] : ^( ASSIGN data= ident expression= expr[True] ) ;
    def modeEffect(self, ):

        value = None

        data = None

        expression = None


        try:
            try:
                # SlimWalkerIdentCheck.g:1156:2: ( ^( ASSIGN data= ident expression= expr[True] ) )
                # SlimWalkerIdentCheck.g:1156:4: ^( ASSIGN data= ident expression= expr[True] )
                pass 
                self.match(self.input, ASSIGN, self.FOLLOW_ASSIGN_in_modeEffect3309)

                self.match(self.input, DOWN, None)
                self._state.following.append(self.FOLLOW_ident_in_modeEffect3323)
                data = self.ident()

                self._state.following.pop()
                self._state.following.append(self.FOLLOW_expr_in_modeEffect3332)
                expression = self.expr(True)

                self._state.following.pop()

                self.match(self.input, UP, None)
                if self._state.backtracking == 0:
                       
                    value = BinaryOperatorTreeNode(IdentifierTreeNode(((data is not None) and [data.name] or [None])[0],
                    		data.start.line, data.start.charPositionInLine + 1),
                    	  	((expression is not None) and [expression.value] or [None])[0], OperatorType.ASSIGN, data.start.line,
                    	  	data.start.charPositionInLine + 1)
                    		





            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return value

    # $ANTLR end "modeEffect"


    # $ANTLR start "errorFeature"
    # SlimWalkerIdentCheck.g:1169:1: errorFeature : ( errorState | errorPropagation );
    def errorFeature(self, ):

        try:
            try:
                # SlimWalkerIdentCheck.g:1170:2: ( errorState | errorPropagation )
                alt64 = 2
                LA64_0 = self.input.LA(1)

                if ((INITIAL <= LA64_0 <= ACTIVATION) or LA64_0 == ERROR) :
                    alt64 = 1
                elif ((IE_PROP <= LA64_0 <= OE_PROP)) :
                    alt64 = 2
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 64, 0, self.input)

                    raise nvae

                if alt64 == 1:
                    # SlimWalkerIdentCheck.g:1170:4: errorState
                    pass 
                    self._state.following.append(self.FOLLOW_errorState_in_errorFeature3352)
                    self.errorState()

                    self._state.following.pop()


                elif alt64 == 2:
                    # SlimWalkerIdentCheck.g:1171:4: errorPropagation
                    pass 
                    self._state.following.append(self.FOLLOW_errorPropagation_in_errorFeature3357)
                    self.errorPropagation()

                    self._state.following.pop()



            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return 

    # $ANTLR end "errorFeature"


    # $ANTLR start "errorClock"
    # SlimWalkerIdentCheck.g:1174:1: errorClock[compileInfo] : ^( ERR_CLOCK i= ident clockType= dataType[compileInfo] ) ;
    def errorClock(self, compileInfo):

        i = None

        clockType = None


        try:
            try:
                # SlimWalkerIdentCheck.g:1175:2: ( ^( ERR_CLOCK i= ident clockType= dataType[compileInfo] ) )
                # SlimWalkerIdentCheck.g:1175:4: ^( ERR_CLOCK i= ident clockType= dataType[compileInfo] )
                pass 
                self.match(self.input, ERR_CLOCK, self.FOLLOW_ERR_CLOCK_in_errorClock3370)

                self.match(self.input, DOWN, None)
                self._state.following.append(self.FOLLOW_ident_in_errorClock3378)
                i = self.ident()

                self._state.following.pop()
                self._state.following.append(self.FOLLOW_dataType_in_errorClock3387)
                clockType = self.dataType(compileInfo)

                self._state.following.pop()
                if self._state.backtracking == 0:
                         
                    if self.declaration_stack[-1].the_component:
                    	self.declaration_stack[-1].the_component.add_clock(((i is not None) and [i.name] or [None])[0], clockType,
                    		i.start.line, i.start.charPositionInLine + 1)
                    				


                self.match(self.input, UP, None)




            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return 

    # $ANTLR end "errorClock"


    # $ANTLR start "errorState"
    # SlimWalkerIdentCheck.g:1186:1: errorState : ( ^( INITIAL i= ident (u= urgent )? (invariant= expr[True] )? ) | ^( ACTIVATION i= ident (u= urgent )? (invariant= expr[True] )? ) | ^( ERROR i= ident (u= urgent )? (invariant= expr[True] )? ) );
    def errorState(self, ):

        i = None

        u = None

        invariant = None


        try:
            try:
                # SlimWalkerIdentCheck.g:1188:2: ( ^( INITIAL i= ident (u= urgent )? (invariant= expr[True] )? ) | ^( ACTIVATION i= ident (u= urgent )? (invariant= expr[True] )? ) | ^( ERROR i= ident (u= urgent )? (invariant= expr[True] )? ) )
                alt71 = 3
                LA71 = self.input.LA(1)
                if LA71 == INITIAL:
                    alt71 = 1
                elif LA71 == ACTIVATION:
                    alt71 = 2
                elif LA71 == ERROR:
                    alt71 = 3
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 71, 0, self.input)

                    raise nvae

                if alt71 == 1:
                    # SlimWalkerIdentCheck.g:1188:4: ^( INITIAL i= ident (u= urgent )? (invariant= expr[True] )? )
                    pass 
                    self.match(self.input, INITIAL, self.FOLLOW_INITIAL_in_errorState3413)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_errorState3422)
                    i = self.ident()

                    self._state.following.pop()
                    # SlimWalkerIdentCheck.g:1191:6: (u= urgent )?
                    alt65 = 2
                    LA65_0 = self.input.LA(1)

                    if (LA65_0 == URGENT) :
                        alt65 = 1
                    if alt65 == 1:
                        # SlimWalkerIdentCheck.g:0:0: u= urgent
                        pass 
                        self._state.following.append(self.FOLLOW_urgent_in_errorState3435)
                        u = self.urgent()

                        self._state.following.pop()



                    # SlimWalkerIdentCheck.g:1193:14: (invariant= expr[True] )?
                    alt66 = 2
                    LA66_0 = self.input.LA(1)

                    if ((AND <= LA66_0 <= CASE) or (NOT <= LA66_0 <= NEQ) or (MSEC <= LA66_0 <= FALSE) or (NAME <= LA66_0 <= FQ_NAME_OR_IDENT) or (TRAJ_EXPR <= LA66_0 <= UNARY_MINUS) or (IDENT <= LA66_0 <= NUMBER)) :
                        alt66 = 1
                    if alt66 == 1:
                        # SlimWalkerIdentCheck.g:0:0: invariant= expr[True]
                        pass 
                        self._state.following.append(self.FOLLOW_expr_in_errorState3449)
                        invariant = self.expr(True)

                        self._state.following.pop()



                    if self._state.backtracking == 0:
                             
                        if self.declaration_stack[-1].the_component:
                        	self.declaration_stack[-1].the_component.add_initial_state(
                        		((i is not None) and [i.name] or [None])[0], ((invariant is not None) and [invariant.value] or [None])[0], u, i.start.line,
                        		i.start.charPositionInLine + 1)
                        				


                    self.match(self.input, UP, None)


                elif alt71 == 2:
                    # SlimWalkerIdentCheck.g:1202:4: ^( ACTIVATION i= ident (u= urgent )? (invariant= expr[True] )? )
                    pass 
                    self.match(self.input, ACTIVATION, self.FOLLOW_ACTIVATION_in_errorState3469)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_errorState3478)
                    i = self.ident()

                    self._state.following.pop()
                    # SlimWalkerIdentCheck.g:1205:6: (u= urgent )?
                    alt67 = 2
                    LA67_0 = self.input.LA(1)

                    if (LA67_0 == URGENT) :
                        alt67 = 1
                    if alt67 == 1:
                        # SlimWalkerIdentCheck.g:0:0: u= urgent
                        pass 
                        self._state.following.append(self.FOLLOW_urgent_in_errorState3491)
                        u = self.urgent()

                        self._state.following.pop()



                    # SlimWalkerIdentCheck.g:1207:14: (invariant= expr[True] )?
                    alt68 = 2
                    LA68_0 = self.input.LA(1)

                    if ((AND <= LA68_0 <= CASE) or (NOT <= LA68_0 <= NEQ) or (MSEC <= LA68_0 <= FALSE) or (NAME <= LA68_0 <= FQ_NAME_OR_IDENT) or (TRAJ_EXPR <= LA68_0 <= UNARY_MINUS) or (IDENT <= LA68_0 <= NUMBER)) :
                        alt68 = 1
                    if alt68 == 1:
                        # SlimWalkerIdentCheck.g:0:0: invariant= expr[True]
                        pass 
                        self._state.following.append(self.FOLLOW_expr_in_errorState3509)
                        invariant = self.expr(True)

                        self._state.following.pop()



                    if self._state.backtracking == 0:
                             
                        if self.declaration_stack[-1].the_component:
                        	self.declaration_stack[-1].the_component.add_activation_state(
                        		((i is not None) and [i.name] or [None])[0], ((invariant is not None) and [invariant.value] or [None])[0], u, i.start.line,
                        		i.start.charPositionInLine + 1)
                        				


                    self.match(self.input, UP, None)


                elif alt71 == 3:
                    # SlimWalkerIdentCheck.g:1216:4: ^( ERROR i= ident (u= urgent )? (invariant= expr[True] )? )
                    pass 
                    self.match(self.input, ERROR, self.FOLLOW_ERROR_in_errorState3528)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_errorState3537)
                    i = self.ident()

                    self._state.following.pop()
                    # SlimWalkerIdentCheck.g:1219:6: (u= urgent )?
                    alt69 = 2
                    LA69_0 = self.input.LA(1)

                    if (LA69_0 == URGENT) :
                        alt69 = 1
                    if alt69 == 1:
                        # SlimWalkerIdentCheck.g:0:0: u= urgent
                        pass 
                        self._state.following.append(self.FOLLOW_urgent_in_errorState3550)
                        u = self.urgent()

                        self._state.following.pop()



                    # SlimWalkerIdentCheck.g:1221:14: (invariant= expr[True] )?
                    alt70 = 2
                    LA70_0 = self.input.LA(1)

                    if ((AND <= LA70_0 <= CASE) or (NOT <= LA70_0 <= NEQ) or (MSEC <= LA70_0 <= FALSE) or (NAME <= LA70_0 <= FQ_NAME_OR_IDENT) or (TRAJ_EXPR <= LA70_0 <= UNARY_MINUS) or (IDENT <= LA70_0 <= NUMBER)) :
                        alt70 = 1
                    if alt70 == 1:
                        # SlimWalkerIdentCheck.g:0:0: invariant= expr[True]
                        pass 
                        self._state.following.append(self.FOLLOW_expr_in_errorState3568)
                        invariant = self.expr(True)

                        self._state.following.pop()



                    if self._state.backtracking == 0:
                             
                        if self.declaration_stack[-1].the_component:
                        	self.declaration_stack[-1].the_component.add_error_state(
                        		((i is not None) and [i.name] or [None])[0], ((invariant is not None) and [invariant.value] or [None])[0], u, i.start.line,
                        		i.start.charPositionInLine + 1)
                        				


                    self.match(self.input, UP, None)



            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return 

    # $ANTLR end "errorState"


    # $ANTLR start "errorPropagation"
    # SlimWalkerIdentCheck.g:1231:1: errorPropagation : ( ^( IE_PROP i= ident ) | ^( OE_PROP i= ident ) );
    def errorPropagation(self, ):

        i = None


        try:
            try:
                # SlimWalkerIdentCheck.g:1233:2: ( ^( IE_PROP i= ident ) | ^( OE_PROP i= ident ) )
                alt72 = 2
                LA72_0 = self.input.LA(1)

                if (LA72_0 == IE_PROP) :
                    alt72 = 1
                elif (LA72_0 == OE_PROP) :
                    alt72 = 2
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 72, 0, self.input)

                    raise nvae

                if alt72 == 1:
                    # SlimWalkerIdentCheck.g:1233:4: ^( IE_PROP i= ident )
                    pass 
                    self.match(self.input, IE_PROP, self.FOLLOW_IE_PROP_in_errorPropagation3594)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_errorPropagation3603)
                    i = self.ident()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                             
                        if self.declaration_stack[-1].the_component:
                        	self.declaration_stack[-1].the_component.add_in_propagation(((i is not None) and [i.name] or [None])[0],
                        		i.start.line, i.start.charPositionInLine + 1)
                        				


                    self.match(self.input, UP, None)


                elif alt72 == 2:
                    # SlimWalkerIdentCheck.g:1242:4: ^( OE_PROP i= ident )
                    pass 
                    self.match(self.input, OE_PROP, self.FOLLOW_OE_PROP_in_errorPropagation3620)

                    self.match(self.input, DOWN, None)
                    self._state.following.append(self.FOLLOW_ident_in_errorPropagation3629)
                    i = self.ident()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                             
                        if self.declaration_stack[-1].the_component:
                        	self.declaration_stack[-1].the_component.add_out_propagation(((i is not None) and [i.name] or [None])[0],
                        		i.start.line, i.start.charPositionInLine + 1)
                        				


                    self.match(self.input, UP, None)



            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return 

    # $ANTLR end "errorPropagation"

    class occurrence_return(TreeRuleReturnScope):
        def __init__(self):
            TreeRuleReturnScope.__init__(self)

            self.dist = None
            self.rate = None
            self.time = None




    # $ANTLR start "occurrence"
    # SlimWalkerIdentCheck.g:1252:1: occurrence returns [dist, rate, time] : d= distribution n= NUMBER ;
    def occurrence(self, ):

        retval = self.occurrence_return()
        retval.start = self.input.LT(1)

        n = None
        d = None


        try:
            try:
                # SlimWalkerIdentCheck.g:1253:2: (d= distribution n= NUMBER )
                # SlimWalkerIdentCheck.g:1253:4: d= distribution n= NUMBER
                pass 
                self._state.following.append(self.FOLLOW_distribution_in_occurrence3658)
                d = self.distribution()

                self._state.following.pop()
                n=self.match(self.input, NUMBER, self.FOLLOW_NUMBER_in_occurrence3662)
                if self._state.backtracking == 0:
                       
                    retval.dist = d
                    retval.rate = n.text
                    # TODO: check why time is unused
                    		





            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return retval

    # $ANTLR end "occurrence"


    # $ANTLR start "distribution"
    # SlimWalkerIdentCheck.g:1262:1: distribution returns [dist] : POISSON ;
    def distribution(self, ):

        dist = None

        try:
            try:
                # SlimWalkerIdentCheck.g:1263:2: ( POISSON )
                # SlimWalkerIdentCheck.g:1263:6: POISSON
                pass 
                self.match(self.input, POISSON, self.FOLLOW_POISSON_in_distribution3685)
                if self._state.backtracking == 0:
                       
                    dist = DistributionType.POISSON
                    		





            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return dist

    # $ANTLR end "distribution"


    # $ANTLR start "errorEvent"
    # SlimWalkerIdentCheck.g:1269:1: errorEvent : ^( ERR_EVENT i= ident (occ= occurrence )? (ts= timeScaleUnit )? ) ;
    def errorEvent(self, ):

        i = None

        occ = None

        ts = None


        try:
            try:
                # SlimWalkerIdentCheck.g:1270:2: ( ^( ERR_EVENT i= ident (occ= occurrence )? (ts= timeScaleUnit )? ) )
                # SlimWalkerIdentCheck.g:1270:4: ^( ERR_EVENT i= ident (occ= occurrence )? (ts= timeScaleUnit )? )
                pass 
                self.match(self.input, ERR_EVENT, self.FOLLOW_ERR_EVENT_in_errorEvent3701)

                if self._state.backtracking == 0:
                         
                    myRate = None
                    myDist = None
                    myTime = None # TODO: get rid of this deprecated stuff
                    time_unit = None
                    				


                self.match(self.input, DOWN, None)
                self._state.following.append(self.FOLLOW_ident_in_errorEvent3716)
                i = self.ident()

                self._state.following.pop()
                # SlimWalkerIdentCheck.g:1278:5: (occ= occurrence )?
                alt73 = 2
                LA73_0 = self.input.LA(1)

                if (LA73_0 == POISSON) :
                    alt73 = 1
                if alt73 == 1:
                    # SlimWalkerIdentCheck.g:1278:6: occ= occurrence
                    pass 
                    self._state.following.append(self.FOLLOW_occurrence_in_errorEvent3726)
                    occ = self.occurrence()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        myRate = ((occ is not None) and [occ.rate] or [None])[0]; myDist = ((occ is not None) and [occ.dist] or [None])[0]; myTime = ((occ is not None) and [occ.time] or [None])[0]




                # SlimWalkerIdentCheck.g:1279:5: (ts= timeScaleUnit )?
                alt74 = 2
                LA74_0 = self.input.LA(1)

                if ((MSEC <= LA74_0 <= DAY)) :
                    alt74 = 1
                if alt74 == 1:
                    # SlimWalkerIdentCheck.g:1279:6: ts= timeScaleUnit
                    pass 
                    self._state.following.append(self.FOLLOW_timeScaleUnit_in_errorEvent3741)
                    ts = self.timeScaleUnit()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        time_unit=ts




                if self._state.backtracking == 0:
                         
                    if self.declaration_stack[-1].the_component:
                    	self.declaration_stack[-1].the_component.add_event(((i is not None) and [i.name] or [None])[0],
                    	myDist, myRate, time_unit, i.start.line, i.start.charPositionInLine + 1)
                    				


                self.match(self.input, UP, None)




            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return 

    # $ANTLR end "errorEvent"


    # $ANTLR start "errorTransition"
    # SlimWalkerIdentCheck.g:1288:1: errorTransition : ^( ERR_TRANS fromState= sourceState trigger= errorTrigger toState= ident ( WHEN guard= modeGuard )? ( WITHIN lower= expr[True] upper= expr[True] )? ( THEN (effect= modeEffect )+ )? ) ;
    def errorTransition(self, ):

        fromState = None

        trigger = None

        toState = None

        guard = None

        lower = None

        upper = None

        effect = None


        try:
            try:
                # SlimWalkerIdentCheck.g:1289:2: ( ^( ERR_TRANS fromState= sourceState trigger= errorTrigger toState= ident ( WHEN guard= modeGuard )? ( WITHIN lower= expr[True] upper= expr[True] )? ( THEN (effect= modeEffect )+ )? ) )
                # SlimWalkerIdentCheck.g:1289:4: ^( ERR_TRANS fromState= sourceState trigger= errorTrigger toState= ident ( WHEN guard= modeGuard )? ( WITHIN lower= expr[True] upper= expr[True] )? ( THEN (effect= modeEffect )+ )? )
                pass 
                self.match(self.input, ERR_TRANS, self.FOLLOW_ERR_TRANS_in_errorTransition3767)

                self.match(self.input, DOWN, None)
                self._state.following.append(self.FOLLOW_sourceState_in_errorTransition3776)
                fromState = self.sourceState()

                self._state.following.pop()
                self._state.following.append(self.FOLLOW_errorTrigger_in_errorTransition3785)
                trigger = self.errorTrigger()

                self._state.following.pop()
                self._state.following.append(self.FOLLOW_ident_in_errorTransition3794)
                toState = self.ident()

                self._state.following.pop()
                if self._state.backtracking == 0:
                         
                    effects = []
                    guard = None
                    time_delay = None
                    				

                # SlimWalkerIdentCheck.g:1298:5: ( WHEN guard= modeGuard )?
                alt75 = 2
                LA75_0 = self.input.LA(1)

                if (LA75_0 == WHEN) :
                    alt75 = 1
                if alt75 == 1:
                    # SlimWalkerIdentCheck.g:1298:6: WHEN guard= modeGuard
                    pass 
                    self.match(self.input, WHEN, self.FOLLOW_WHEN_in_errorTransition3807)
                    self._state.following.append(self.FOLLOW_modeGuard_in_errorTransition3823)
                    guard = self.modeGuard()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        guard = guard




                # SlimWalkerIdentCheck.g:1301:5: ( WITHIN lower= expr[True] upper= expr[True] )?
                alt76 = 2
                LA76_0 = self.input.LA(1)

                if (LA76_0 == WITHIN) :
                    alt76 = 1
                if alt76 == 1:
                    # SlimWalkerIdentCheck.g:1301:6: WITHIN lower= expr[True] upper= expr[True]
                    pass 
                    self.match(self.input, WITHIN, self.FOLLOW_WITHIN_in_errorTransition3836)
                    self._state.following.append(self.FOLLOW_expr_in_errorTransition3845)
                    lower = self.expr(True)

                    self._state.following.pop()
                    self._state.following.append(self.FOLLOW_expr_in_errorTransition3850)
                    upper = self.expr(True)

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        time_delay = (((lower is not None) and [lower.value] or [None])[0], ((upper is not None) and [upper.value] or [None])[0])




                # SlimWalkerIdentCheck.g:1303:5: ( THEN (effect= modeEffect )+ )?
                alt78 = 2
                LA78_0 = self.input.LA(1)

                if (LA78_0 == THEN) :
                    alt78 = 1
                if alt78 == 1:
                    # SlimWalkerIdentCheck.g:1303:6: THEN (effect= modeEffect )+
                    pass 
                    self.match(self.input, THEN, self.FOLLOW_THEN_in_errorTransition3862)
                    # SlimWalkerIdentCheck.g:1305:6: (effect= modeEffect )+
                    cnt77 = 0
                    while True: #loop77
                        alt77 = 2
                        LA77_0 = self.input.LA(1)

                        if (LA77_0 == ASSIGN) :
                            alt77 = 1


                        if alt77 == 1:
                            # SlimWalkerIdentCheck.g:1305:7: effect= modeEffect
                            pass 
                            self._state.following.append(self.FOLLOW_modeEffect_in_errorTransition3879)
                            effect = self.modeEffect()

                            self._state.following.pop()
                            if self._state.backtracking == 0:
                                effects.append(effect) 



                        else:
                            if cnt77 >= 1:
                                break #loop77

                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            eee = EarlyExitException(77, self.input)
                            raise eee

                        cnt77 += 1





                if self._state.backtracking == 0:
                         
                    if self.declaration_stack[-1].the_component:
                        if trigger == '@activation':
                            self.declaration_stack[-1].the_component.add_reactivation_transition(((fromState is not None) and [fromState.name] or [None])[0],
                                ((toState is not None) and [toState.name] or [None])[0], guard, time_delay, effects, fromState.start.line, fromState.start.charPositionInLine + 1)
                        else:
                            self.declaration_stack[-1].the_component.add_transition(((fromState is not None) and [fromState.name] or [None])[0],
                            trigger, ((toState is not None) and [toState.name] or [None])[0], guard, time_delay, effects, fromState.start.line, fromState.start.charPositionInLine + 1)
                    				


                self.match(self.input, UP, None)




            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return 

    # $ANTLR end "errorTransition"

    class sourceState_return(TreeRuleReturnScope):
        def __init__(self):
            TreeRuleReturnScope.__init__(self)

            self.name = None




    # $ANTLR start "sourceState"
    # SlimWalkerIdentCheck.g:1318:1: sourceState returns [name] : (i= ident | TIMES );
    def sourceState(self, ):

        retval = self.sourceState_return()
        retval.start = self.input.LT(1)

        i = None


        try:
            try:
                # SlimWalkerIdentCheck.g:1319:5: (i= ident | TIMES )
                alt79 = 2
                LA79_0 = self.input.LA(1)

                if ((NAME <= LA79_0 <= FQ_NAME_OR_IDENT) or LA79_0 == IDENT) :
                    alt79 = 1
                elif (LA79_0 == TIMES) :
                    alt79 = 2
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 79, 0, self.input)

                    raise nvae

                if alt79 == 1:
                    # SlimWalkerIdentCheck.g:1319:9: i= ident
                    pass 
                    self._state.following.append(self.FOLLOW_ident_in_sourceState3918)
                    i = self.ident()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                             
                        retval.name = ((i is not None) and [i.name] or [None])[0] 
                        	



                elif alt79 == 2:
                    # SlimWalkerIdentCheck.g:1323:9: TIMES
                    pass 
                    self.match(self.input, TIMES, self.FOLLOW_TIMES_in_sourceState3934)
                    if self._state.backtracking == 0:
                             
                        retval.name = "*"
                        	




            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return retval

    # $ANTLR end "sourceState"


    # $ANTLR start "errorTrigger"
    # SlimWalkerIdentCheck.g:1329:1: errorTrigger returns [name] : ( IDENT | RESET | ATACTIVATION );
    def errorTrigger(self, ):

        name = None

        IDENT4 = None

        try:
            try:
                # SlimWalkerIdentCheck.g:1330:2: ( IDENT | RESET | ATACTIVATION )
                alt80 = 3
                LA80 = self.input.LA(1)
                if LA80 == IDENT:
                    alt80 = 1
                elif LA80 == RESET:
                    alt80 = 2
                elif LA80 == ATACTIVATION:
                    alt80 = 3
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 80, 0, self.input)

                    raise nvae

                if alt80 == 1:
                    # SlimWalkerIdentCheck.g:1330:4: IDENT
                    pass 
                    IDENT4=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_errorTrigger3959)
                    if self._state.backtracking == 0:
                           
                        name = IDENT4.text
                        		



                elif alt80 == 2:
                    # SlimWalkerIdentCheck.g:1334:4: RESET
                    pass 
                    self.match(self.input, RESET, self.FOLLOW_RESET_in_errorTrigger3968)
                    if self._state.backtracking == 0:
                           
                        name = "reset"
                        		



                elif alt80 == 3:
                    # SlimWalkerIdentCheck.g:1338:4: ATACTIVATION
                    pass 
                    self.match(self.input, ATACTIVATION, self.FOLLOW_ATACTIVATION_in_errorTrigger3977)
                    if self._state.backtracking == 0:
                           
                        name = "@activation"
                        		




            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
        finally:

            pass

        return name

    # $ANTLR end "errorTrigger"

    # $ANTLR start "synpred103_SlimWalkerIdentCheck"
    def synpred103_SlimWalkerIdentCheck_fragment(self, ):
        # SlimWalkerIdentCheck.g:974:4: (i= ident )
        # SlimWalkerIdentCheck.g:974:4: i= ident
        pass 
        self._state.following.append(self.FOLLOW_ident_in_synpred103_SlimWalkerIdentCheck2793)
        i = self.ident()

        self._state.following.pop()


    # $ANTLR end "synpred103_SlimWalkerIdentCheck"



    # $ANTLR start "synpred104_SlimWalkerIdentCheck"
    def synpred104_SlimWalkerIdentCheck_fragment(self, ):
        # SlimWalkerIdentCheck.g:982:4: ( ^( NAME i1= ident i2= ident ) )
        # SlimWalkerIdentCheck.g:982:4: ^( NAME i1= ident i2= ident )
        pass 
        self.match(self.input, NAME, self.FOLLOW_NAME_in_synpred104_SlimWalkerIdentCheck2803)

        self.match(self.input, DOWN, None)
        self._state.following.append(self.FOLLOW_ident_in_synpred104_SlimWalkerIdentCheck2807)
        i1 = self.ident()

        self._state.following.pop()
        self._state.following.append(self.FOLLOW_ident_in_synpred104_SlimWalkerIdentCheck2811)
        i2 = self.ident()

        self._state.following.pop()

        self.match(self.input, UP, None)


    # $ANTLR end "synpred104_SlimWalkerIdentCheck"




    # Delegated rules

    def synpred103_SlimWalkerIdentCheck(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred103_SlimWalkerIdentCheck_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred104_SlimWalkerIdentCheck(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred104_SlimWalkerIdentCheck_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success



    # lookup tables for DFA #54

    DFA54_eot = DFA.unpack(
        u"\43\uffff"
        )

    DFA54_eof = DFA.unpack(
        u"\43\uffff"
        )

    DFA54_min = DFA.unpack(
        u"\1\56\30\uffff\1\0\11\uffff"
        )

    DFA54_max = DFA.unpack(
        u"\1\u0085\30\uffff\1\0\11\uffff"
        )

    DFA54_accept = DFA.unpack(
        u"\1\uffff\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1"
        u"\15\1\16\1\17\1\20\1\21\1\22\1\23\1\24\1\25\1\26\1\27\1\30\1\uffff"
        u"\1\31\1\uffff\1\33\1\34\4\uffff\1\32"
        )

    DFA54_special = DFA.unpack(
        u"\31\uffff\1\0\11\uffff"
        )

            
    DFA54_transition = [
        DFA.unpack(u"\1\6\1\12\1\13\1\14\1\15\1\23\26\uffff\1\1\1\5\1\7\1"
        u"\4\1\3\1\2\1\24\1\10\1\11\7\uffff\5\35\1\20\1\16\1\17\1\21\1\22"
        u"\1\26\1\27\26\uffff\1\31\1\32\3\uffff\1\25\1\34\1\uffff\1\32\1"
        u"\30"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"\1\uffff"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"")
    ]

    # class definition for DFA #54

    class DFA54(DFA):
        def specialStateTransition(self_, s, input):
            # convince pylint that my self_ magic is ok ;)
            # pylint: disable-msg=E0213

            # pretend we are a member of the recognizer
            # thus semantic predicates can be evaluated
            self = self_.recognizer

            _s = s

            if s == 0: 
                LA54_25 = input.LA(1)

                 
                index54_25 = input.index()
                input.rewind()
                s = -1
                if (self.synpred103_SlimWalkerIdentCheck()):
                    s = 26

                elif (self.synpred104_SlimWalkerIdentCheck()):
                    s = 34

                 
                input.seek(index54_25)
                if s >= 0:
                    return s

            if self._state.backtracking >0:
                raise BacktrackingFailed
            nvae = NoViableAltException(self_.getDescription(), 54, _s, input)
            self_.error(nvae)
            raise nvae
 

    FOLLOW_packageSpecification_in_specification59 = frozenset([1, 4, 106, 107, 108, 109])
    FOLLOW_declaration_in_specification70 = frozenset([1, 4, 106, 107, 108, 109])
    FOLLOW_PACKAGE_in_packageSpecification88 = frozenset([2])
    FOLLOW_ident_in_packageSpecification102 = frozenset([5])
    FOLLOW_PUBLIC_in_packageSpecification120 = frozenset([4, 6, 106, 107, 108, 109, 124, 125, 132])
    FOLLOW_declaration_in_packageSpecification136 = frozenset([4, 6, 106, 107, 108, 109, 124, 125, 132])
    FOLLOW_PRIVATE_in_packageSpecification145 = frozenset([4, 6, 106, 107, 108, 109, 124, 125, 132])
    FOLLOW_declaration_in_packageSpecification162 = frozenset([4, 6, 106, 107, 108, 109, 124, 125, 132])
    FOLLOW_ident_in_packageSpecification181 = frozenset([3])
    FOLLOW_COMP_TYPE_in_declaration218 = frozenset([2])
    FOLLOW_FDIR_in_declaration229 = frozenset([6, 11, 13, 15, 16, 17, 18, 19, 116, 124, 125, 132])
    FOLLOW_componentCategory_in_declaration242 = frozenset([6, 124, 125, 132])
    FOLLOW_ident_in_declaration256 = frozenset([6, 110, 111, 112, 113, 114, 124, 125, 132])
    FOLLOW_portSpec_in_declaration273 = frozenset([6, 110, 111, 112, 113, 114, 124, 125, 132])
    FOLLOW_ident_in_declaration288 = frozenset([3])
    FOLLOW_COMP_IMPL_in_declaration318 = frozenset([2])
    FOLLOW_FDIR_in_declaration329 = frozenset([6, 11, 13, 15, 16, 17, 18, 19, 116, 124, 125, 132])
    FOLLOW_componentCategory_in_declaration341 = frozenset([6, 124, 125, 132])
    FOLLOW_ident_in_declaration355 = frozenset([2, 6, 11, 13, 14, 15, 16, 17, 18, 19, 40, 41, 62, 116, 117, 118, 124, 125, 126, 127, 128, 131, 132])
    FOLLOW_subcomponent_in_declaration378 = frozenset([2, 6, 11, 13, 14, 15, 16, 17, 18, 19, 40, 41, 62, 116, 117, 118, 124, 125, 126, 127, 128, 131, 132])
    FOLLOW_portConnection_in_declaration392 = frozenset([6, 40, 41, 62, 117, 118, 124, 125, 126, 127, 128, 131, 132])
    FOLLOW_flow_in_declaration399 = frozenset([6, 40, 41, 62, 117, 118, 124, 125, 128, 131, 132])
    FOLLOW_mode_in_declaration428 = frozenset([6, 40, 41, 62, 117, 118, 124, 125, 128, 132])
    FOLLOW_modeTransition_in_declaration453 = frozenset([6, 117, 118, 124, 125, 132])
    FOLLOW_ident_in_declaration467 = frozenset([3])
    FOLLOW_ERR_TYPE_in_declaration496 = frozenset([2])
    FOLLOW_ident_in_declaration510 = frozenset([6, 40, 41, 62, 119, 120, 124, 125, 132])
    FOLLOW_errorFeature_in_declaration540 = frozenset([6, 40, 41, 62, 119, 120, 124, 125, 132])
    FOLLOW_ident_in_declaration554 = frozenset([3])
    FOLLOW_ERR_IMPL_in_declaration582 = frozenset([2])
    FOLLOW_ident_in_declaration596 = frozenset([6, 40, 41, 62, 121, 122, 123, 124, 125, 132])
    FOLLOW_errorClock_in_declaration618 = frozenset([6, 40, 41, 62, 121, 122, 123, 124, 125, 132])
    FOLLOW_errorState_in_declaration635 = frozenset([6, 40, 41, 62, 121, 123, 124, 125, 132])
    FOLLOW_errorEvent_in_declaration648 = frozenset([6, 121, 123, 124, 125, 132])
    FOLLOW_errorTransition_in_declaration661 = frozenset([6, 123, 124, 125, 132])
    FOLLOW_ident_in_declaration675 = frozenset([3])
    FOLLOW_PROCESS_in_componentCategory709 = frozenset([1])
    FOLLOW_THREAD_GROUP_in_componentCategory719 = frozenset([1])
    FOLLOW_THREAD_in_componentCategory729 = frozenset([1])
    FOLLOW_PROCESSOR_in_componentCategory739 = frozenset([1])
    FOLLOW_MEMORY_in_componentCategory749 = frozenset([1])
    FOLLOW_DEVICE_in_componentCategory759 = frozenset([1])
    FOLLOW_BUS_in_componentCategory769 = frozenset([1])
    FOLLOW_SYSTEM_in_componentCategory779 = frozenset([1])
    FOLLOW_BOOL_in_dataType803 = frozenset([1])
    FOLLOW_CLOCK_in_dataType819 = frozenset([1, 90, 91, 92, 93, 94])
    FOLLOW_timeScaleUnit_in_dataType824 = frozenset([1])
    FOLLOW_CONTINUOUS_in_dataType837 = frozenset([1])
    FOLLOW_ENUM_in_dataType855 = frozenset([2])
    FOLLOW_ident_in_dataType870 = frozenset([3, 6, 124, 125, 132])
    FOLLOW_INT_in_dataType889 = frozenset([1])
    FOLLOW_REAL_in_dataType899 = frozenset([1])
    FOLLOW_intRange_in_dataType911 = frozenset([1])
    FOLLOW_MSEC_in_timeScaleUnit933 = frozenset([1])
    FOLLOW_SEC_in_timeScaleUnit943 = frozenset([1])
    FOLLOW_MIN_in_timeScaleUnit953 = frozenset([1])
    FOLLOW_HOUR_in_timeScaleUnit963 = frozenset([1])
    FOLLOW_DAY_in_timeScaleUnit973 = frozenset([1])
    FOLLOW_NUMBER_in_intRange998 = frozenset([133])
    FOLLOW_NUMBER_in_intRange1002 = frozenset([1])
    FOLLOW_IEPORT_in_portSpec1028 = frozenset([2])
    FOLLOW_ident_in_portSpec1037 = frozenset([3])
    FOLLOW_OEPORT_in_portSpec1057 = frozenset([2])
    FOLLOW_ident_in_portSpec1066 = frozenset([3, 26])
    FOLLOW_NONBLOCKING_in_portSpec1076 = frozenset([3])
    FOLLOW_IDPORT_in_portSpec1095 = frozenset([2])
    FOLLOW_ident_in_portSpec1104 = frozenset([83, 84, 85, 86, 87, 88, 133])
    FOLLOW_dataType_in_portSpec1118 = frozenset([3, 6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_portSpec1132 = frozenset([3])
    FOLLOW_ODPORT_in_portSpec1154 = frozenset([2])
    FOLLOW_ident_in_portSpec1163 = frozenset([83, 84, 85, 86, 87, 88, 133])
    FOLLOW_dataType_in_portSpec1177 = frozenset([3, 6, 29, 30, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_portSpec1191 = frozenset([3, 29, 30])
    FOLLOW_OBSERVABLE_in_portSpec1203 = frozenset([3, 30])
    FOLLOW_ALARM_in_portSpec1214 = frozenset([3])
    FOLLOW_ERRORPORT_in_portSpec1235 = frozenset([2])
    FOLLOW_ident_in_portSpec1239 = frozenset([3, 67])
    FOLLOW_POISSON_in_portSpec1247 = frozenset([133])
    FOLLOW_NUMBER_in_portSpec1251 = frozenset([3])
    FOLLOW_NAME_in_ident1281 = frozenset([2])
    FOLLOW_ident_in_ident1295 = frozenset([6, 124, 125, 132])
    FOLLOW_ident_in_ident1309 = frozenset([3])
    FOLLOW_FQ_NAME_OR_IDENT_in_ident1325 = frozenset([2])
    FOLLOW_ident_in_ident1339 = frozenset([6, 124, 125, 132])
    FOLLOW_ident_in_ident1353 = frozenset([3])
    FOLLOW_IDENT_in_ident1366 = frozenset([1])
    FOLLOW_DATA_in_subcomponent1386 = frozenset([2])
    FOLLOW_ident_in_subcomponent1402 = frozenset([6, 83, 84, 85, 86, 87, 88, 124, 125, 132, 133])
    FOLLOW_ident_in_subcomponent1421 = frozenset([6, 83, 84, 85, 86, 87, 88, 124, 125, 132, 133])
    FOLLOW_dataType_in_subcomponent1444 = frozenset([3, 6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_subcomponent1459 = frozenset([3])
    FOLLOW_componentCategory_in_subcomponent1484 = frozenset([2])
    FOLLOW_ident_in_subcomponent1498 = frozenset([6, 124, 125, 132])
    FOLLOW_ident_in_subcomponent1512 = frozenset([3, 6, 36, 37, 38, 124, 125, 132])
    FOLLOW_ident_in_subcomponent1530 = frozenset([3, 6, 36, 37, 38, 124, 125, 132])
    FOLLOW_binding_in_subcomponent1553 = frozenset([3, 36, 37, 38])
    FOLLOW_STORED_in_binding1596 = frozenset([2])
    FOLLOW_ident_in_binding1610 = frozenset([3])
    FOLLOW_RUNNING_in_binding1631 = frozenset([2])
    FOLLOW_ident_in_binding1645 = frozenset([3])
    FOLLOW_ACCESSES_in_binding1661 = frozenset([2])
    FOLLOW_ident_in_binding1675 = frozenset([3])
    FOLLOW_EVENT_CONNECTION_in_portConnection1696 = frozenset([2])
    FOLLOW_ident_in_portConnection1717 = frozenset([6, 124, 125, 132])
    FOLLOW_ident_in_portConnection1731 = frozenset([3, 6, 105, 124, 125, 132])
    FOLLOW_ident_in_portConnection1746 = frozenset([3, 6, 105, 124, 125, 132])
    FOLLOW_PASSIVE_in_portConnection1762 = frozenset([3])
    FOLLOW_DATA_CONNECTION_in_portConnection1788 = frozenset([2])
    FOLLOW_ident_in_portConnection1807 = frozenset([6, 124, 125, 132])
    FOLLOW_ident_in_portConnection1821 = frozenset([3, 6, 124, 125, 132])
    FOLLOW_ident_in_portConnection1836 = frozenset([3, 6, 124, 125, 132])
    FOLLOW_FLOW_in_flow1869 = frozenset([2])
    FOLLOW_ident_in_flow1880 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_flow1887 = frozenset([3, 6, 124, 125, 132])
    FOLLOW_ident_in_flow1896 = frozenset([3, 6, 124, 125, 132])
    FOLLOW_INITIAL_in_mode1922 = frozenset([2])
    FOLLOW_ident_in_mode1935 = frozenset([3, 6, 44, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_urgent_in_mode1948 = frozenset([3, 6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_mode1962 = frozenset([3])
    FOLLOW_ACTIVATION_in_mode1991 = frozenset([2])
    FOLLOW_ident_in_mode2005 = frozenset([3, 6, 44, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_urgent_in_mode2019 = frozenset([3, 6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_mode2033 = frozenset([3])
    FOLLOW_ERROR_in_mode2056 = frozenset([2])
    FOLLOW_ident_in_mode2069 = frozenset([3, 6, 44, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_urgent_in_mode2082 = frozenset([3, 6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_mode2096 = frozenset([3])
    FOLLOW_NORMAL_in_mode2121 = frozenset([2])
    FOLLOW_ident_in_mode2135 = frozenset([3, 6, 44, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_urgent_in_mode2148 = frozenset([3, 6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_mode2166 = frozenset([3])
    FOLLOW_URGENT_in_urgent2197 = frozenset([2])
    FOLLOW_expr_in_urgent2201 = frozenset([3])
    FOLLOW_NOT_in_expr2226 = frozenset([2])
    FOLLOW_expr_in_expr2230 = frozenset([3])
    FOLLOW_IMP_in_expr2242 = frozenset([2])
    FOLLOW_expr_in_expr2246 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_expr2251 = frozenset([3])
    FOLLOW_IFF_in_expr2263 = frozenset([2])
    FOLLOW_expr_in_expr2267 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_expr2272 = frozenset([3])
    FOLLOW_XNOR_in_expr2284 = frozenset([2])
    FOLLOW_expr_in_expr2288 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_expr2293 = frozenset([3])
    FOLLOW_OR_in_expr2305 = frozenset([2])
    FOLLOW_expr_in_expr2309 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_expr2314 = frozenset([3])
    FOLLOW_AND_in_expr2326 = frozenset([2])
    FOLLOW_expr_in_expr2330 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_expr2335 = frozenset([3])
    FOLLOW_XOR_in_expr2347 = frozenset([2])
    FOLLOW_expr_in_expr2351 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_expr2356 = frozenset([3])
    FOLLOW_EQ_in_expr2368 = frozenset([2])
    FOLLOW_expr_in_expr2372 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_expr2377 = frozenset([3])
    FOLLOW_NEQ_in_expr2389 = frozenset([2])
    FOLLOW_expr_in_expr2393 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_expr2398 = frozenset([3])
    FOLLOW_LT_in_expr2410 = frozenset([2])
    FOLLOW_expr_in_expr2414 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_expr2419 = frozenset([3])
    FOLLOW_LE_in_expr2431 = frozenset([2])
    FOLLOW_expr_in_expr2435 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_expr2440 = frozenset([3])
    FOLLOW_GT_in_expr2452 = frozenset([2])
    FOLLOW_expr_in_expr2456 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_expr2461 = frozenset([3])
    FOLLOW_GE_in_expr2473 = frozenset([2])
    FOLLOW_expr_in_expr2477 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_expr2482 = frozenset([3])
    FOLLOW_PLUS_in_expr2494 = frozenset([2])
    FOLLOW_expr_in_expr2498 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_expr2503 = frozenset([3])
    FOLLOW_MINUS_in_expr2515 = frozenset([2])
    FOLLOW_expr_in_expr2519 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_expr2524 = frozenset([3])
    FOLLOW_TIMES_in_expr2536 = frozenset([2])
    FOLLOW_expr_in_expr2540 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_expr2545 = frozenset([3])
    FOLLOW_DIVIDE_in_expr2557 = frozenset([2])
    FOLLOW_expr_in_expr2561 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_expr2566 = frozenset([3])
    FOLLOW_MOD_in_expr2579 = frozenset([2])
    FOLLOW_expr_in_expr2583 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_expr2588 = frozenset([3])
    FOLLOW_CASE_in_expr2604 = frozenset([2])
    FOLLOW_expr_in_expr2616 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_expr2621 = frozenset([6, 46, 47, 48, 49, 50, 51, 52, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_OTHERWISE_in_expr2639 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_expr2647 = frozenset([3])
    FOLLOW_DERIVATIVE_in_expr2663 = frozenset([2])
    FOLLOW_ident_in_expr2677 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_expr2691 = frozenset([3, 103])
    FOLLOW_PER_in_expr2705 = frozenset([90, 91, 92, 93, 94])
    FOLLOW_timeScaleUnit_in_expr2709 = frozenset([3])
    FOLLOW_TRAJ_EXPR_in_expr2728 = frozenset([2])
    FOLLOW_NUMBER_in_expr2741 = frozenset([3])
    FOLLOW_TRUE_in_expr2756 = frozenset([1])
    FOLLOW_FALSE_in_expr2767 = frozenset([1])
    FOLLOW_NUMBER_in_expr2782 = frozenset([1])
    FOLLOW_ident_in_expr2793 = frozenset([1])
    FOLLOW_NAME_in_expr2803 = frozenset([2])
    FOLLOW_ident_in_expr2807 = frozenset([6, 124, 125, 132])
    FOLLOW_ident_in_expr2811 = frozenset([3])
    FOLLOW_UNARY_MINUS_in_expr2822 = frozenset([2])
    FOLLOW_expr_in_expr2826 = frozenset([3])
    FOLLOW_timeScaleOperator_in_expr2839 = frozenset([1])
    FOLLOW_MSEC_in_timeScaleOperator2864 = frozenset([2])
    FOLLOW_expr_in_timeScaleOperator2868 = frozenset([3])
    FOLLOW_SEC_in_timeScaleOperator2881 = frozenset([2])
    FOLLOW_expr_in_timeScaleOperator2885 = frozenset([3])
    FOLLOW_MIN_in_timeScaleOperator2898 = frozenset([2])
    FOLLOW_expr_in_timeScaleOperator2902 = frozenset([3])
    FOLLOW_HOUR_in_timeScaleOperator2915 = frozenset([2])
    FOLLOW_expr_in_timeScaleOperator2919 = frozenset([3])
    FOLLOW_DAY_in_timeScaleOperator2932 = frozenset([2])
    FOLLOW_expr_in_timeScaleOperator2936 = frozenset([3])
    FOLLOW_TIMES_in_sourceMode2958 = frozenset([1])
    FOLLOW_ident_in_sourceMode2974 = frozenset([1])
    FOLLOW_MODE_TRANS_in_modeTransition2994 = frozenset([2])
    FOLLOW_sourceMode_in_modeTransition3013 = frozenset([6, 124, 125, 132])
    FOLLOW_ident_in_modeTransition3026 = frozenset([3, 6, 42, 53, 56, 71, 72, 75, 124, 125, 132])
    FOLLOW_modeTrigger_in_modeTransition3040 = frozenset([3, 53, 71, 72])
    FOLLOW_WHEN_in_modeTransition3051 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_modeGuard_in_modeTransition3065 = frozenset([3, 53, 72])
    FOLLOW_WITHIN_in_modeTransition3076 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_modeTransition3084 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_modeTransition3089 = frozenset([3, 53])
    FOLLOW_THEN_in_modeTransition3100 = frozenset([57])
    FOLLOW_modeEffect_in_modeTransition3115 = frozenset([3, 57])
    FOLLOW_MODE_TRANS_PROB_in_modeTransition3147 = frozenset([2])
    FOLLOW_ident_in_modeTransition3160 = frozenset([6, 124, 125, 132])
    FOLLOW_ident_in_modeTransition3173 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_modeTransition3186 = frozenset([3])
    FOLLOW_ident_in_modeTrigger3221 = frozenset([1])
    FOLLOW_OR_in_modeTrigger3233 = frozenset([2])
    FOLLOW_modeTrigger_in_modeTrigger3237 = frozenset([6, 42, 56, 75, 124, 125, 132])
    FOLLOW_modeTrigger_in_modeTrigger3241 = frozenset([3])
    FOLLOW_RESET_in_modeTrigger3255 = frozenset([1])
    FOLLOW_ATACTIVATION_in_modeTrigger3265 = frozenset([1])
    FOLLOW_expr_in_modeGuard3288 = frozenset([1])
    FOLLOW_ASSIGN_in_modeEffect3309 = frozenset([2])
    FOLLOW_ident_in_modeEffect3323 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_modeEffect3332 = frozenset([3])
    FOLLOW_errorState_in_errorFeature3352 = frozenset([1])
    FOLLOW_errorPropagation_in_errorFeature3357 = frozenset([1])
    FOLLOW_ERR_CLOCK_in_errorClock3370 = frozenset([2])
    FOLLOW_ident_in_errorClock3378 = frozenset([83, 84, 85, 86, 87, 88, 133])
    FOLLOW_dataType_in_errorClock3387 = frozenset([3])
    FOLLOW_INITIAL_in_errorState3413 = frozenset([2])
    FOLLOW_ident_in_errorState3422 = frozenset([3, 6, 44, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_urgent_in_errorState3435 = frozenset([3, 6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_errorState3449 = frozenset([3])
    FOLLOW_ACTIVATION_in_errorState3469 = frozenset([2])
    FOLLOW_ident_in_errorState3478 = frozenset([3, 6, 44, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_urgent_in_errorState3491 = frozenset([3, 6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_errorState3509 = frozenset([3])
    FOLLOW_ERROR_in_errorState3528 = frozenset([2])
    FOLLOW_ident_in_errorState3537 = frozenset([3, 6, 44, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_urgent_in_errorState3550 = frozenset([3, 6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_errorState3568 = frozenset([3])
    FOLLOW_IE_PROP_in_errorPropagation3594 = frozenset([2])
    FOLLOW_ident_in_errorPropagation3603 = frozenset([3])
    FOLLOW_OE_PROP_in_errorPropagation3620 = frozenset([2])
    FOLLOW_ident_in_errorPropagation3629 = frozenset([3])
    FOLLOW_distribution_in_occurrence3658 = frozenset([133])
    FOLLOW_NUMBER_in_occurrence3662 = frozenset([1])
    FOLLOW_POISSON_in_distribution3685 = frozenset([1])
    FOLLOW_ERR_EVENT_in_errorEvent3701 = frozenset([2])
    FOLLOW_ident_in_errorEvent3716 = frozenset([3, 67, 90, 91, 92, 93, 94])
    FOLLOW_occurrence_in_errorEvent3726 = frozenset([3, 90, 91, 92, 93, 94])
    FOLLOW_timeScaleUnit_in_errorEvent3741 = frozenset([3])
    FOLLOW_ERR_TRANS_in_errorTransition3767 = frozenset([2])
    FOLLOW_sourceState_in_errorTransition3776 = frozenset([42, 56, 132])
    FOLLOW_errorTrigger_in_errorTransition3785 = frozenset([6, 124, 125, 132])
    FOLLOW_ident_in_errorTransition3794 = frozenset([3, 53, 71, 72])
    FOLLOW_WHEN_in_errorTransition3807 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_modeGuard_in_errorTransition3823 = frozenset([3, 53, 72])
    FOLLOW_WITHIN_in_errorTransition3836 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_errorTransition3845 = frozenset([6, 46, 47, 48, 49, 50, 51, 74, 75, 76, 77, 78, 79, 80, 81, 82, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 124, 125, 129, 130, 132, 133])
    FOLLOW_expr_in_errorTransition3850 = frozenset([3, 53])
    FOLLOW_THEN_in_errorTransition3862 = frozenset([57])
    FOLLOW_modeEffect_in_errorTransition3879 = frozenset([3, 57])
    FOLLOW_ident_in_sourceState3918 = frozenset([1])
    FOLLOW_TIMES_in_sourceState3934 = frozenset([1])
    FOLLOW_IDENT_in_errorTrigger3959 = frozenset([1])
    FOLLOW_RESET_in_errorTrigger3968 = frozenset([1])
    FOLLOW_ATACTIVATION_in_errorTrigger3977 = frozenset([1])
    FOLLOW_ident_in_synpred103_SlimWalkerIdentCheck2793 = frozenset([1])
    FOLLOW_NAME_in_synpred104_SlimWalkerIdentCheck2803 = frozenset([2])
    FOLLOW_ident_in_synpred104_SlimWalkerIdentCheck2807 = frozenset([6, 124, 125, 132])
    FOLLOW_ident_in_synpred104_SlimWalkerIdentCheck2811 = frozenset([3])



def main(argv, stdin=sys.stdin, stdout=sys.stdout, stderr=sys.stderr):
    from antlr3.main import WalkerMain
    main = WalkerMain(SlimWalkerIdentCheck)
    main.stdin = stdin
    main.stdout = stdout
    main.stderr = stderr
    main.execute(argv)


if __name__ == '__main__':
    main(sys.argv)
